#####   G]l̼ۨ˥ANOVA(Two way repeated measures ANOVA) #######################
#жgƦW
data = Unit_10_bev_coffin
#жgܶW(ܶW١AṲ̄@wnݳ椸2.7ƮسC)
dependent_var = c("ίvD")
#жg]lW(ܶW١AṲ̄@wnݳ椸2.7ƮسC)
independent_var = c("~", "@ئ]")
#еĤ@Ӧ]lUOƧǡApGOƦrAШ̱zƱƧǪƦrgҦpc("1", "2", "3")
level_A = c("ifi", "@", "")
#еĤGӦ]lUOƧǡApGOƦrAШ̱zƱƧǪƦrgҦpc("1", "2", "3", "4")
level_B = c("50mg", "100mg", "150mg", "200mg")
#жg˥sXܶ
id_var = c("id")
#жgnXGɮצWr
save_file = c("twR_out")
##########################################################
library(tidyverse)
library(rstatix)
library(lessR)
library(rlist)
library(erer)
library(psych)
library(writexl)
##########################################################
datr = dplyr::select(data, all_of(id_var), all_of(dependent_var), all_of(independent_var))
colnames(datr) = c("ID", "DPR", "IV1", "IV2")
datr$ID  = as.factor(datr$ID)
datr$IV1 = as.factor(datr$IV1)
datr$IV2 = as.factor(datr$IV2)
datr$IV1 = datr$IV1 %>% ordered(levels = level_A)
datr$IV2 = datr$IV2 %>% ordered(levels = level_B)

##############################################################################
if(!is.numeric(datr$DPR)){
  AB_output = c("ܶOƭܶALkG]l̼ۨ˥ܲƤRC")
  AB_output = data.frame(AB_output)
  colnames(AB_output) = c("ĵi")
  AB_outcsv = paste0(save_file, ".xlsx")
  write_xlsx(AB_output, AB_outcsv)
  cat("ĵiGܶOƭܶALkG]l̼ۨ˥ܲƤRC")
} else {
  if(length(unique(datr$DPR)) == 1){
    AB1_output = c("ܶu@ӭȡALkG]l̼ۨ˥ܲƤRC")
    AB1_output = data.frame(AB1_output)
    colnames(AB1_output) = c("ĵi")
    AB1_outcsv = paste0(save_file, ".xlsx")
    write_xlsx(AB1_output, AB1_outcsv)
    cat("ĵiGܶu@ӭȡALkG]l̼ۨ˥ܲƤRC")
  }
  if(length(unique(datr$DPR)) == 2){
    AB2_output = c("ܶuGӭȡAAXG]l̼ۨ˥ܲƤRC")
    AB2_output = data.frame(AB2_output)
    colnames(AB2_output) = c("ĵi")
    AB2_outcsv = paste0(save_file, ".xlsx")
    write_xlsx(AB2_output, AB2_outcsv)
    cat("ĵiGܶuGӭȡAAXG]l̼ۨ˥ܲƤRC")
  } else {
check_0 = table(datr$IV1, datr$IV2)
if (any(check_0 == 0 | any(check_0 == 1))) {
  c_tab = CrossTable(datr$IV1, datr$IV2, prop.r = F, prop.c = F,
                     prop.t = F, prop.chisq = F)
  check_0_1 = data.frame(matrix(c_tab$t, nrow = length(unique(datr$IV1))))
  rown = levels(datr$IV1)
  check_0_1 = cbind(rown, check_0_1)
  colnames(check_0_1) = c("ܶէO", levels(datr$IV2))
  tw_ano_result = paste0("ӦܶeӮ椤tƬO01ӮALkG]lܲƤRC",
                         "аѨ椤ƤtAШϥΦXO覡ӸѨM@DC")
  tw_ano_result = data.frame(tw_ano_result)
  tw_ano = list(tw_ano_result, check_0_1)
  mix_AOV.savecsv = paste0(save_file, ".csv")
  write.list(z = tw_ano, file = mix_AOV.savecsv, row.names = F)
  cat("ĵi:ӦܶeӮ椤tƬ01ӮALkϥΤG]lܲƤRC") 
 } else {
   if(length(unique(datr$IV1)) == 1 | length(unique(datr$IV2)) == 1) {
     B_output = data.frame(c("ܶOu1ALkG]lW߼˥ANOVAC"))
     colnames(B_output) = c("ĵi")
     cat("ĵiGܶOu1ALkG]lW߼˥ANOVAC")
     B_outcsv = paste0(save_file, ".xlsx")
     write_xlsx(B_output, B_outcsv)
     
   } else {
     
     dat1 = datr
     norm_tw  = dat1 %>%  group_by(IV1, IV2) %>% shapiro_test(DPR)
     norm_tw  = data.frame(norm_tw)
     skew_kur = dat1 %>% group_by(IV1, IV2) %>%
                         summarise(skew = skew(DPR), kurtosis = kurtosi(DPR), .groups = 'drop')
     skew_kur = data.frame(skew_kur)
     aa1 = norm_tw[ ,1:2]
     aa2 = round(norm_tw[ ,4:5], 3)
     aa3 = round(skew_kur[ ,3:4], 3)
     aa4 = cbind(aa1, aa2, aa3)
     colnames(aa4) = c(independent_var, "ShapiroVWilkέpq", "p", "A", "p׭")
         
norm_f = function(ii) {
       if (norm_tw$p[ii] > 0.05) {
       norm_out = paste0(norm_tw$IV1[ii], "P", norm_tw$IV2[ii], "s骺ShapiroVWilkέpq = ", 
                         round(norm_tw$statistic[ii], 3),  "Ap = ", round(norm_tw$p[ii], 3), 
                         " > 0.05Aܦ@s骺`AʰwߡC")
     } else {
       norm_1 = paste0(norm_tw$IV1[ii], "P", norm_tw$IV2[ii], "s骺ShapiroVWilkέpq = ", 
                       round(norm_tw$statistic[ii], 3),  "Ap = ", round(norm_tw$p[ii], 3), 
                       " < 0.05 Ai@B˩w@s骺AȻPp׭ȡC")
       if(abs(skew_kur$skew[ii]) >= 3) { 
         norm_ske = paste0("A = ", round(skew_kur$skew[ii], 3), "A  3AܦYA{HC")
       } else {
         norm_ske = paste0("A = ", round(skew_kur$skew[ii], 3), "A < 3AܨSYA{HC")  
       }
       
       if(abs(skew_kur$kurtosis[ii]) >= 10) { 
         norm_kur = paste0("p׭ = ", round(skew_kur$kurtosis[ii], 3), "A  10AܦYL󥭩Zΰ~k{HC")
       } else {
         norm_kur = paste0("p׭ = ", round(skew_kur$kurtosis[ii], 3), "A < 10AܨSYL󥭩Zΰ~k{HC")  
       }
       if(abs(skew_kur$skew[ii]) >= 3 & abs(skew_kur$kurtosis[ii]) >= 10) {
         norm_out = paste0(norm_1, norm_ske, norm_kur, "ѩShapiroVWilk`A˩wܫD`AA",
                           "BAܦYA{HAp׭ܦYL󥭩Zΰ~k{HA",
                           "]iHPw@sYHϱ`AʡC",
                           "(Ū̥iѦҡu10.4G]l̼ۨ˥ANOVAwv@p`AMDѨM覡C)")
       }
       if(abs(skew_kur$skew[ii]) >= 3) {
         norm_out = paste0(norm_1, norm_ske, norm_kur, "ѩShapiroVWilk`A˩wܫD`AA",
                           "BAܦYA{HA]iHPwHϱ`AʡC", 
                           "(Ū̥iѦҡu10.4G]l̼ۨ˥ANOVAwv@p`AMDѨM覡C)")
       }
       
       if(abs(skew_kur$kurtosis[ii]) >= 10) {
         norm_out = paste0(norm_1, norm_ske, norm_kur, "ѩShapiroVWilk`A˩wܫD`AA",
                           "Bp׭ܦYL󥭩Zΰ~k{HA]iHPwHϱ`AʡC", 
                           "(Ū̥iѦҡu10.4G]l̼ۨ˥ANOVAwv@p`AMDѨM覡C)")
       }
       
       if(abs(skew_kur$skew[ii]) < 3 & abs(skew_kur$kurtosis[ii]) < 10) {
         norm_out = paste0(norm_1, norm_ske, norm_kur, "MShapiroVWilk`A˩wܫD`A", 
                           "AMӰAܨSYA{HAp׭ܨSYL󥭩Zΰ~k{HA",
                           "@siHΩG]l̼ۨ˥ANOVA˩wC" )
       }
     }
} 

kl = length(unique(datr$IV1))*length(unique(datr$IV2))
kh = t(c(1:kl))
kh1 = to("ii", kl)
colnames(kh) = kh1
tw_norm_re = apply(kh, 2, norm_f)
tw_norm_re1 = paste0(tw_norm_re, collapse = "")

#˥ơBơBзǮt
nmsdr_f = function(qq){
  datr_msd = datr
  datr_k = datr_msd[datr_msd$IV1 == qq, ]
  #datr_k$DPR = as.numeric(datr_k$DPR)
  d = tapply(datr_k$DPR, datr_k$IV2,
             function(x) format(describe(x)))
  d1 = list.rbind(d)
  d2 = d1[ ,c(2, 3, 4)]
  d3 = round(as.numeric(unlist(d2)), 3)
  d4 = matrix(d3, nrow = length(unique(datr_k$IV2)))
  colnames(d4) = c("N", "", "зǮt")
  d5 = t(d4)
  d6 = c("N", "", "зǮt")
  d7 = cbind(d6, d5)
  #jkla = paste0(Between_subjects_var, "էO", qq)
  d8 = c(qq, "", "")
  d9 = cbind(d8, d7)
  d10 = data.frame(d9)
}
nmsdr1 = t(c(levels(datr$IV1)))
nmsdr11 = to("qq", length(levels(datr$IV1)))
colnames(nmsdr1) = nmsdr11
nmsdr_out = apply(nmsdr1, 2, nmsdr_f)
nmsdr_out1 = list.rbind(nmsdr_out)
nmsdr_out1 = data.frame(nmsdr_out1)
colnames(nmsdr_out1) = c("ܶէO", "ԭzέp", levels(datr$IV2))

##############################################################################
twR.aov <- anova_test(
  data = datr, dv = DPR, wid = ID,
  within = c(IV1, IV2), detailed = T, effect.size = "pes", 
)

twR_ano_tab = get_anova_table(twR.aov)
twR_ano_tab = data.frame(twR_ano_tab) %>% select(c(1, 4, 5, 2, 3, 6, 7, 9))
twR_ano_tab = twR_ano_tab[-1, ]
var_1 = paste0(independent_var, collapse = ":")
twR_ano_tab$Effect = c(independent_var, var_1)
colnames(twR_ano_tab) = c("ܲӷ", "SS", "~tSS", "df", "~tdf",  "F", "p", "b2") 
twR_ano_tab$p = round(twR_ano_tab$p, 5)
#########################################################################################
Mauch_tab = twR.aov$`Mauchly's Test for Sphericity`[ ,1:4]
Mauch_AB = paste0(independent_var, collapse = ":")
 
if(length(levels(datr$IV1)) == 2 & length(levels(datr$IV2)) >= 3) {
  Mauch_tab$Effect = c(independent_var[2], Mauch_AB)
  colnames(Mauch_tab) = c("ĪG", "Mauchly's W", "p", "۩")
  }
if(length(levels(datr$IV1)) >= 3 & length(levels(datr$IV2)) == 2) {
  Mauch_tab$Effect = c(independent_var[1], Mauch_AB)
  colnames(Mauch_tab) = c("ĪG", "Mauchly's W", "p", "۩") 
}
if(length(levels(datr$IV1)) >= 3 & length(levels(datr$IV2)) >= 3) {
  Mauch_tab$Effect = c(independent_var, Mauch_AB)
  colnames(Mauch_tab) = c("ĪG", "Mauchly's W", "p", "۩") 
}


if(length(levels(datr$IV1)) == 2 & length(levels(datr$IV2)) != 2) {
  if(Mauch_tab$p[1] <= 0.05) {
    Mauch_A1_out = paste0(Mauch_tab$ĪG[1], "Mauchly˩wMauchly's W = ", 
                          Mauch_tab$`Mauchly's W`[1], "Ap < 0.05AywߡA",
                          "ϥGreenhouse-Geisser (GG)󥿪έppȨ˩wܶ۩ʡC") 
  } else {
    Mauch_A1_out = paste0(Mauch_tab$ĪG[1], "Mauchly˩wMauchly's W = ", 
                          Mauch_tab$`Mauchly's W`[1], "Ap > 0.05AywߡC" ) 
    
  }
  if(Mauch_tab$p[2] <= 0.05) {
    Mauch_B1_out = paste0(Mauch_tab$ĪG[2], "Mauchly˩wMauchly's W = ", 
                          Mauch_tab$`Mauchly's W`[2], "Ap < 0.05AywߡA",
                          "ϥGreenhouse-Geisser (GG)󥿪έppȨ˩w۩ʡC" ) 
  } else {
    Mauch_B1_out = paste0(Mauch_tab$ĪG[2], "Mauchly˩wMauchly's W = ", 
                          Mauch_tab$`Mauchly's W`[2], "Ap > 0.05AywߡC" ) 
  }
  Mauch_out = paste0(Mauch_A1_out, Mauch_B1_out)
}

if(length(levels(datr$IV1)) != 2 & length(levels(datr$IV2)) == 2) {
  if(Mauch_tab$p[1] <= 0.05) {
    Mauch_A1_out = paste0(Mauch_tab$ĪG[1], "Mauchly˩wMauchly's W = ", 
                          Mauch_tab$`Mauchly's W`[1], "Ap < 0.05AywߡA",
                          "ϥGreenhouse-Geisser (GG)󥿪έppȨ˩w۩ʡC") 
  } else {
    Mauch_A1_out = paste0(Mauch_tab$ĪG[1], "Mauchly˩wMauchly's W = ", 
                          Mauch_tab$`Mauchly's W`[1], "Ap > 0.05AywߡC" ) 
    
  }
  if(Mauch_tab$p[2] <= 0.05) {
    Mauch_B1_out = paste0(Mauch_tab$ĪG[2], "Mauchly˩wMauchly's W = ", 
                          Mauch_tab$`Mauchly's W`[2], "Ap < 0.05AywߡA",
                          "ϥGreenhouse-Geisser (GG)󥿪έppȨ˩w۩ʡC" ) 
  } else {
    Mauch_B1_out = paste0(Mauch_tab$ĪG[2], "Mauchly˩wMauchly's W = ", 
                          Mauch_tab$`Mauchly's W`[2], "Ap > 0.05AywߡC" ) 
    
  }
  Mauch_out = paste0(Mauch_A1_out, Mauch_B1_out)
}

if(length(levels(datr$IV1)) >= 3 & length(levels(datr$IV2)) >= 3) {
if(Mauch_tab$p[1] <= 0.05) {
  Mauch_A1_out = paste0(Mauch_tab$ĪG[1], "Mauchly˩wMauchly's W = ", 
                        Mauch_tab$`Mauchly's W`[1], "Ap < 0.05AywߡA",
                        "ϥGreenhouse-Geisser (GG)󥿪έppȨ˩w۩ʡC") 
} else {
  Mauch_A1_out = paste0(Mauch_tab$ĪG[1], "Mauchly˩wMauchly's W = ", 
                        Mauch_tab$`Mauchly's W`[1], "Ap > 0.05AywߡC" ) 
  
}
if(Mauch_tab$p[2] <= 0.05) {
  Mauch_B1_out = paste0(Mauch_tab$ĪG[2], "Mauchly˩wMauchly's W = ", 
                        Mauch_tab$`Mauchly's W`[2], "Ap < 0.05AywߡA",
                        "ϥGreenhouse-Geisser (GG)󥿪έppȨ˩w۩ʡC" ) 
} else {
  Mauch_B1_out = paste0(Mauch_tab$ĪG[2], "Mauchly˩wMauchly's W = ", 
                        Mauch_tab$`Mauchly's W`[2], "Ap > 0.05AywߡC" ) 
  
}

if(Mauch_tab$p[2] <= 0.05) {
  Mauch_AB1_out = paste0(Mauch_tab$ĪG[3], "Mauchly˩wMauchly's W = ", 
                         Mauch_tab$`Mauchly's W`[3], "Ap < 0.05AywߡA", 
                         "ϥGreenhouse-Geisser (GG)󥿪έppȨ˩w۩ʡC" ) 
} else {
  Mauch_AB1_out = paste0(Mauch_tab$ĪG[3], "Mauchly˩wMauchly's W = ", 
                         Mauch_tab$`Mauchly's W`[3], 
                         "Ap > 0.05AywߡC" ) 
}
  Mauch_out = paste0(Mauch_A1_out, Mauch_B1_out, Mauch_AB1_out)
}

#############################################################################################
if(twR_ano_tab$p[1] > 0.05) {
  twR_main_A = paste0(independent_var[1], "", dependent_var,
                      "SۥDnĪGAF", "(", twR_ano_tab$df[1], ", ", twR_ano_tab$~tdf[1], ") = ",  
                      twR_ano_tab$F[1], "Ap = ", twR_ano_tab$p[1], " > 0.05Ab2 = ", 
                      twR_ano_tab$b2[1], "C")
} else {
  if(twR_ano_tab$p[1] <= 0.05 & twR_ano_tab$p[1] > 0.01){
    uu1 = c(" < 0.05")
  }
  if(twR_ano_tab$p[1] <= 0.01 & twR_ano_tab$p[1] > 0.001){
    uu1 = c(" < 0.01")
  }
  if(twR_ano_tab$p[1] <= 0.001){
    uu1 = c(" < 0.001")
  }
  twR_main_A = paste0(independent_var[1], "", dependent_var,
                      "ۥDnĪGAF", "(", twR_ano_tab$df[1], ", ", twR_ano_tab$~tdf[1], ") = ",  
                      twR_ano_tab$F[1], "Ap = ", twR_ano_tab$p[1], uu1, "Ab2 = ", 
                      twR_ano_tab$b2[1], "C")
}

if(twR_ano_tab$p[2] > 0.05) {
  twR_main_B = paste0(independent_var[2], "", dependent_var,
                      "SۥDnĪGAF", "(", twR_ano_tab$df[2], ", ", twR_ano_tab$~tdf[2], ") = ",  
                      twR_ano_tab$F[2], "Ap = ", twR_ano_tab$p[2], " > 0.05Ab2 = ", 
                      twR_ano_tab$b2[2], "C")
} else {
  if(twR_ano_tab$p[2] <= 0.05 & twR_ano_tab$p[2] > 0.01){
    uu2 = c(" < 0.05")
  }
  if(twR_ano_tab$p[2] <= 0.01 & twR_ano_tab$p[2] > 0.001){
    uu2 = c(" < 0.01")
  }
  if(twR_ano_tab$p[2] <= 0.001){
    uu2 = c(" < 0.001")
  }
  twR_main_B = paste0(independent_var[2], "", dependent_var,
                      "ۥDnĪGAF", "(", twR_ano_tab$df[2], ", ", twR_ano_tab$~tdf[2], ") = ",  
                      twR_ano_tab$F[2], "Ap = ", twR_ano_tab$p[2], uu2, "Ab2 = ", 
                      twR_ano_tab$b2[2], "C")
}

if(twR_ano_tab$p[3] > 0.05) {
  twR_main_AB = paste0(independent_var[1], "P", independent_var[2], "", dependent_var,
                      "S椬@ήĪGAF", "(", twR_ano_tab$df[3], ", ", twR_ano_tab$~tdf[3], ") = ",  
                      twR_ano_tab$F[3], "Ap = ", twR_ano_tab$p[3], " > 0.05Ab2 = ", 
                      twR_ano_tab$b2[3], "C")
} else {
  if(twR_ano_tab$p[3] <= 0.05 & twR_ano_tab$p[3] > 0.01){
    pp1 = c(" < 0.05")
  }
  if(twR_ano_tab$p[3] <= 0.01 & twR_ano_tab$p[3] > 0.001){
    pp1 = c(" < 0.01")
  }
  if(twR_ano_tab$p[3] <= 0.001){
    pp1 = c(" < 0.001")
  }
  twR_main_AB = paste0(independent_var[1], "P", independent_var[2], "", dependent_var,
                       "椬@ήĪGAF", "(", twR_ano_tab$df[3], ", ", twR_ano_tab$~tdf[3], ") = ",  
                       twR_ano_tab$F[3], "Ap = ", twR_ano_tab$p[3], pp1, "Ab2 = ", 
                       twR_ano_tab$b2[3], "C")
}
twR_out_re = paste0(twR_main_A, twR_main_B, twR_main_AB)

#############################################################################################
##¥DnĪGIV1
IV1_sim <- datr %>%
  group_by(IV1) %>%
  anova_test(dv = DPR, wid = ID, within = IV2, detailed = T, effect.size = "pes") %>%
  get_anova_table() %>%
  adjust_pvalue(method = "bonferroni")
IV1_sim = IV1_sim %>% filter(Effect == "IV2")

# IV1¥DnĪGt
IV1_sim_pair <- datr %>%
  group_by(IV1) %>%
  pairwise_t_test(
    DPR ~ IV2, paired = TRUE,
    p.adjust.method = "bonferroni"
  )
# IV1¥DnĪG
simple_IV1 =  function(simIV1) {
  sim_IV1 = IV1_sim %>%
    filter(IV1 == levels(datr$IV1)[simIV1])
  if(sim_IV1$p.adj > 0.05) {
    post_IV1_sim = c("") 
  } else {
    if(length(levels(datr$IV2)) == 2) {
       A1_IV1_sim_pair = IV1_sim_pair %>% filter(IV1 == levels(datr$IV1)[simIV1])
      if(A1_IV1_sim_pair$statistic > 0) {
        post_IV1_sim = paste0(A1_IV1_sim_pair$group1, " > ", A1_IV1_sim_pair$group2, collapse = "F")
      }
      if(A1_IV1_sim_pair$statistic < 0) {
        post_IV1_sim = paste0(A1_IV1_sim_pair$group2, " > ", A1_IV1_sim_pair$group1, collapse = "F")
      }
    }
    if(length(levels(datr$IV2)) >= 3) {  
       sim_IV1_lar = IV1_sim_pair %>%
       filter(IV1 == levels(datr$IV1)[simIV1] & statistic > 0 & p.adj <= 0.05)
       sim_IV1_sm = IV1_sim_pair %>%
       filter(IV1 == levels(datr$IV1)[simIV1] & statistic < 0 & p.adj <= 0.05)
    if(nrow(sim_IV1_lar) == 0 & nrow(sim_IV1_sm) == 0) {
       post_IV1_sim = c("")
      }
    if(nrow(sim_IV1_lar) != 0 & nrow(sim_IV1_sm) == 0) {
      post_IV1_sim = paste0(sim_IV1_lar$group1, " > ", sim_IV1_lar$group2, collapse = "F")
      }  
    if(nrow(sim_IV1_lar) == 0 & nrow(sim_IV1_sm) != 0) {
       post_IV1_sim = paste0(sim_IV1_sm$group2, " > ", sim_IV1_sm$group1, collapse = "F")
      } 
     if(nrow(sim_IV1_lar) != 0 & nrow(sim_IV1_sm) != 0) {
       la_IV1 = paste0(sim_IV1_lar$group1, " > ", sim_IV1_lar$group2, collapse = "F")
       sm_IV1 = paste0(sim_IV1_sm$group2, " > ", sim_IV1_sm$group1, collapse = "F")
       post_IV1_sim = paste0(la_IV1, "F", sm_IV1)
      }
     }
    }
  sim_IV1_a = cbind(sim_IV1, post_IV1_sim)
  sim_IV1_a = sim_IV1_a[ ,c(1, 5, 6, 3, 4, 7, 8, 10, 12)]
  colnames(sim_IV1_a) = c("ܲӷ", "SS",  "~tSS", "df", "~tdf", "F", "p.adj", 
                          "b2", "Bonferroniվƫ")
  sim_IV1_a1 = sim_IV1_a
}
simIV1 = t(c(1:length(levels(datr$IV1))))
simIV11 = to("A", length(levels(datr$IV1)))
colnames(simIV1) = simIV11
sim_IV1_out = apply(simIV1, 2, simple_IV1)
sim_IV1_out1 = list.rbind(sim_IV1_out)
sim_IV1_out1$p.adj = round(sim_IV1_out1$p.adj, 5)

##¥DnĪGIV1Gi
simple_IV1_re =  function(AA) {
  sim_IV1a = IV1_sim %>%  filter(IV1 == levels(datr$IV1)[AA])
  sim_IV1a$p.adj = round(sim_IV1a$p.adj, 5)
if(sim_IV1a$p.adj > 0.05) {
    sim_IV1_re2 = paste0("", independent_var[1], "O", levels(datr$IV1)[AA], "ӨA", independent_var[2],
                        "S۪¥DnĪGAF", "(", sim_IV1a$DFn, ", ", sim_IV1a$DFd, ") = ",  
                        sim_IV1a$F, "Aվp = ", sim_IV1a$p.adj, " > 0.05Ab2 = ", 
                        sim_IV1a$pes, "C")
    
  } else {
    if(sim_IV1a$p.adj <= 0.05 & sim_IV1a$p.adj > 0.01){
      zx = " < 0.05"
    }
    if(sim_IV1a$p.adj <= 0.01 & sim_IV1a$p.adj > 0.001){
      zx = " < 0.01"
    }
    if(sim_IV1a$p.adj <= 0.001){
      zx = " < 0.001"
    }
    sim_IV1_re = paste0("", independent_var[1], "O", levels(datr$IV1)[AA], "ӨA", independent_var[2],
                      "۪¥DnĪGAF", "(", sim_IV1a$DFn, ", ", sim_IV1a$DFd, ") = ",  
                      sim_IV1a$F, "Aվp = ", sim_IV1a$p.adj, zx, "Ab2 = ", sim_IV1a$pes, "C")
    
   if(length(levels(datr$IV2)) == 2) {
    sim_IV1_A1 = IV1_sim_pair %>% filter(IV1 == levels(datr$IV1)[AA])
   if(sim_IV1_A1$statistic > 0) {
      sim_IV1_re1 = paste0(independent_var[1], "O", levels(datr$IV1)[AA], 
                           "", independent_var[2], "O", sim_IV1_A1$group1, "b", dependent_var, 
                           "ۦaj", independent_var[1], "O", levels(datr$IV1)[AA], 
                           "", independent_var[2], "O", sim_IV1_A1$group2, "C")
                           
    } 
    if(sim_IV1_A1$statistic < 0) {
      sim_IV1_re1 = paste0(independent_var[1], "O", levels(datr$IV1)[AA], 
                           "", independent_var[2], "O", sim_IV1_A1$group2, "b", dependent_var, 
                           "ۦaj", independent_var[1], "O", levels(datr$IV1)[AA], 
                           "", independent_var[2], "O", sim_IV1_A1$group1, "C")
    } 
   }
  
  if(length(levels(datr$IV2)) >= 3) {
  sim_IV1_lara = IV1_sim_pair %>%
    filter(IV1 == levels(datr$IV1)[AA] & statistic > 0 & p.adj <= 0.05)
  sim_IV1_sma = IV1_sim_pair %>%
    filter(IV1 == levels(datr$IV1)[AA] & statistic < 0 & p.adj <= 0.05)
  if(nrow(sim_IV1_lara) == 0 & nrow(sim_IV1_sma) == 0) {
    sim_IV1_re1 = paste0("")
  }
  if(nrow(sim_IV1_lara) != 0 & nrow(sim_IV1_sma) == 0) {
    sim_IV1_la1 = paste0(independent_var[1], "O", levels(datr$IV1)[AA], 
                       "", independent_var[2], "O", sim_IV1_lara$group1, "b", dependent_var, 
                       "ۦaj", independent_var[1], "O", levels(datr$IV1)[AA], 
                       "", independent_var[2], "O", sim_IV1_lara$group2, "C")
    sim_IV1_la2 = paste0(sim_IV1_la1, collapse = "" )
    sim_IV1_re1 = paste0("BonferroniƫվܡG", sim_IV1_la2)
  }  
  if(nrow(sim_IV1_lara) == 0 & nrow(sim_IV1_sma) != 0) {
    sim_IV1_sma1 = paste0(independent_var[1], "O", levels(datr$IV1)[AA], 
                        "", independent_var[2], "O", sim_IV1_sma$group2, "b", dependent_var, 
                        "ۦaj", independent_var[1], "O", levels(datr$IV1)[AA], 
                        "", independent_var[2], "O", sim_IV1_sma$group1, "C")
    sim_IV1_sma2 = paste0(sim_IV1_sma1, collapse = "" )
    sim_IV1_re1 = paste0("BonferroniƫվܡG", sim_IV1_sma2)
  } 
  if(nrow(sim_IV1_lara) != 0 & nrow(sim_IV1_sma) != 0) {
    sim_IV1_la = paste0(independent_var[1], "O", levels(datr$IV1)[AA], 
                        "", independent_var[2], "O", sim_IV1_lara$group1, "b", dependent_var, 
                        "ۦaj", independent_var[1], "O", levels(datr$IV1)[AA], 
                        "", independent_var[2], "O", sim_IV1_lara$group2, "C")
    sim_IV1_la1 = paste0(sim_IV1_la, collapse = "" )
    sim_IV1_sma1 = paste0(independent_var[1], "O", levels(datr$IV1)[AA], 
                        "", independent_var[2], "O", sim_IV1_sma$group2, "b", dependent_var, 
                        "ۦaj", independent_var[1], "O", levels(datr$IV1)[AA], 
                        "", independent_var[2], "O", sim_IV1_sma$group1, "C")
    sim_IV1_sma2 = paste0(sim_IV1_sma1, collapse = "" )
    sim_IV1_re1 = paste0("BonferroniƫվܡG", sim_IV1_la1, sim_IV1_sma2)
    }
  }
  sim_IV1_re2 = paste0(sim_IV1_re, sim_IV1_re1)   
 }
}
simIV1a = t(1:length(levels(datr$IV1)))
simIV1a1 = to("AA", length(levels(datr$IV1)))
colnames(simIV1a) = simIV1a1
sim_IV1_out_re = apply(simIV1a, 2, simple_IV1_re)
sim_IV1_out_re_1 = paste0(sim_IV1_out_re, collapse = "")

##¥DnĪGIV2
IV2_sim <- datr %>%
  group_by(IV2) %>%
  anova_test(dv = DPR, wid = ID, within = IV1, detailed = T, effect.size = "pes") %>%
  get_anova_table() %>%
  adjust_pvalue(method = "bonferroni")

IV2_sim = IV2_sim %>% filter(Effect == "IV1")
# Pairwise comparisons between IV2 groups
IV2_sim_pair <- datr %>%
  group_by(IV2) %>%
  pairwise_t_test(
    DPR ~ IV1, paired = TRUE,
    p.adjust.method = "bonferroni"
  )

#IV2¥DnĪG
simple_IV2 =  function(simIV2) {
  sim_IV2 = IV2_sim %>%
    filter(IV2 == levels(datr$IV2)[simIV2])
  if(sim_IV2$p.adj > 0.05) {
    post_IV2_sim = c("") 
  } else {
    if(length(levels(datr$IV1)) == 2) {
      A1_IV2_sim_pair = IV2_sim_pair %>% filter(IV2 == levels(datr$IV2)[simIV2])
      if(A1_IV2_sim_pair$statistic > 0) {
        post_IV2_sim = paste0(A1_IV2_sim_pair$group1, " > ", A1_IV2_sim_pair$group2, collapse = "F")
      }
      if(A1_IV2_sim_pair$statistic < 0) {
        post_IV2_sim = paste0(A1_IV2_sim_pair$group2, " > ", A1_IV2_sim_pair$group1, collapse = "F")
      }
    }
    if(length(levels(datr$IV1)) >= 3) {  
      sim_IV2_lar = IV2_sim_pair %>%
        filter(IV2 == levels(datr$IV2)[simIV2] & statistic > 0 & p.adj <= 0.05)
      sim_IV2_sm = IV2_sim_pair %>%
        filter(IV2 == levels(datr$IV2)[simIV2] & statistic < 0 & p.adj <= 0.05)
      if(nrow(sim_IV2_lar) == 0 & nrow(sim_IV2_sm) == 0) {
        post_IV2_sim = c("")
      }
      if(nrow(sim_IV2_lar) != 0 & nrow(sim_IV2_sm) == 0) {
        post_IV2_sim = paste0(sim_IV2_lar$group1, " > ", sim_IV2_lar$group2, collapse = "F")
      }  
      if(nrow(sim_IV2_lar) == 0 & nrow(sim_IV2_sm) != 0) {
        post_IV2_sim = paste0(sim_IV2_sm$group2, " > ", sim_IV2_sm$group1, collapse = "F")
      } 
      if(nrow(sim_IV2_lar) != 0 & nrow(sim_IV2_sm) != 0) {
        la_IV2 = paste0(sim_IV2_lar$group1, " > ", sim_IV2_lar$group2, collapse = "F")
        sm_IV2 = paste0(sim_IV2_sm$group2, " > ", sim_IV2_sm$group1, collapse = "F")
        post_IV2_sim = paste0(la_IV2, "F", sm_IV2)
      }
    }
  }
  sim_IV2_a = cbind(sim_IV2, post_IV2_sim)
  sim_IV2_a = sim_IV2_a[ ,c(1, 5, 6, 3, 4, 7, 8, 10, 12)]
  colnames(sim_IV2_a) = c("ܲӷ", "SS",  "~tSS", "df", "~tdf", "F", "p.adj", 
                          "b2", "Bonferroniվƫ")
  sim_IV2_a1 = sim_IV2_a
}
simIV2 = t(c(1:length(levels(datr$IV2))))
simIV21 = to("Ab", length(levels(datr$IV2)))
colnames(simIV2) = simIV21
sim_IV2_out = apply(simIV2, 2, simple_IV2)
sim_IV2_out1 = list.rbind(sim_IV2_out)
sim_IV2_out1$p.adj = round(sim_IV2_out1$p.adj, 5)

#¥DnĪGIV2i
simple_IV2_re =  function(simIV2a) {
  sim_IV2a = IV2_sim %>%  filter(IV2 == levels(datr$IV2)[simIV2a])
  sim_IV2a$p.adj = round(sim_IV2a$p.adj, 5)
  if(sim_IV2a$p.adj > 0.05) {
    sim_IV2_re  = paste0("", independent_var[2], "O", levels(datr$IV2)[simIV2a], "ӨA", independent_var[1],
                        "S۪¥DnĪGAF", "(", sim_IV2a$DFn, ", ", sim_IV2a$DFd, ") = ",  
                        sim_IV2a$F, "Aվp = ", sim_IV2a$p.adj, " > 0.05Ab2 = ", 
                        sim_IV2a$pes, "C")
    sim_IV2_re1 = c("") 
    sim_IV2_re2 = c(sim_IV2_re, sim_IV2_re1)
  } else {
    if(sim_IV2a$p.adj <= 0.05 & sim_IV2a$p.adj > 0.01){
      zxa1 = " < 0.05"
    }
    if(sim_IV2a$p.adj <= 0.01 & sim_IV2a$p.adj > 0.001){
      zxa1 = " < 0.01"
    }
    if(sim_IV2a$p.adj <= 0.001){
      zxa1 = " < 0.001"
    }
    sim_IV2_re = paste0("", independent_var[2], "O", levels(datr$IV2)[simIV2a], "ӨA", independent_var[1],
                        "۪¥DnĪGAF", "(", sim_IV2a$DFn, ", ", sim_IV2a$DFd, ") = ",  
                        sim_IV2a$F, "Aվp = ", sim_IV2a$p.adj, zxa1, "Ab2 = ", 
                        sim_IV2a$pes, "C") 
    if(length(levels(datr$IV1)) == 2) {
      sim_IV2_A1 = IV2_sim_pair %>% filter(IV2 == levels(datr$IV2)[simIV2a])
      if(sim_IV2_A1$statistic > 0) {
        sim_IV2_re1 = paste0(independent_var[2], "O", levels(datr$IV2)[simIV2a], 
                             "", independent_var[1], "O", sim_IV2_A1$group1, "b", dependent_var, 
                             "ۦaj", independent_var[2], "O", levels(datr$IV2)[simIV2a], 
                             "", independent_var[1], "O", sim_IV2_A1$group2, "C")
        
      } 
      if(sim_IV2_A1$statistic < 0) {
        sim_IV2_re1 = paste0(independent_var[2], "O", levels(datr$IV2)[simIV2a], 
                             "", independent_var[1], "O", sim_IV2_A1$group2, "b", dependent_var, 
                             "ۦaj", independent_var[2], "O", levels(datr$IV2)[simIV2a], 
                             "", independent_var[1], "O", sim_IV2_A1$group1, "C")
      } 
    }
    if(length(levels(datr$IV1)) >= 3) {
      sim_IV2_lara = IV2_sim_pair %>%
        filter(IV2 == levels(datr$IV2)[simIV2a] & statistic > 0 & p.adj <= 0.05)
      sim_IV2_sma = IV2_sim_pair %>%
        filter(IV2 == levels(datr$IV2)[simIV2a] & statistic < 0 & p.adj <= 0.05)
      if(nrow(sim_IV2_lara) == 0 & nrow(sim_IV2_sma) == 0) {
        sim_IV2_re1 = paste0("")
      }
      if(nrow(sim_IV2_lara) != 0 & nrow(sim_IV2_sma) == 0) {
        sim_IV2_la1 = paste0(independent_var[2], "O", levels(datr$IV2)[simIV2a], 
                             "", independent_var[1], "O", sim_IV2_lara$group1, "b", dependent_var, 
                             "ۦaj", independent_var[2], "O", levels(datr$IV2)[simIV2a], 
                             "", independent_var[1], "O", sim_IV2_lara$group2, "C")
        sim_IV2_la2 = paste0(sim_IV2_la, collapse = "" )
        sim_IV2_re1 = paste0("BonferroniƫվܡG", sim_IV2_la2)
      }  
      if(nrow(sim_IV2_lara) == 0 & nrow(sim_IV2_sma) != 0) {
        sim_IV2_sma1 = paste0(independent_var[2], "O", levels(datr$IV2)[simIV2a], 
                              "", independent_var[1], "O", sim_IV2_sma$group2, "b", dependent_var, 
                              "ۦaj", independent_var[2], "O", levels(datr$IV2)[simIV2a], 
                              "", independent_var[1], "O", sim_IV2_sma$group1, "C")
        sim_IV2_sma2 = paste0(sim_IV2_sma1, collapse = "" )
        sim_IV2_re1 = paste0("BonferroniƫվܡG", sim_IV2_sma2)
      } 
      if(nrow(sim_IV2_lara) != 0 & nrow(sim_IV2_sma) != 0) {
        sim_IV2_la = paste0(independent_var[2], "O", levels(datr$IV2)[simIV2a], 
                            "", independent_var[1], "O", sim_IV2_lara$group1, "b", dependent_var, 
                            "ۦaj", independent_var[2], "O", levels(datr$IV2)[simIV2a], 
                            "", independent_var[1], "O", sim_IV2_lara$group2, "C")
        sim_IV2_la1 = paste0(sim_IV2_la, collapse = "" )
        sim_IV2_sma1 = paste0(independent_var[2], "O", levels(datr$IV2)[simIV2a], 
                              "", independent_var[1], "O", sim_IV2_sma$group2, "b", dependent_var, 
                              "ۦaj", independent_var[2], "O", levels(datr$IV2)[simIV2a], 
                              "", independent_var[1], "O", sim_IV2_sma$group1, "C")
        sim_IV2_sma2 = paste0(sim_IV2_sma1, collapse = "" )
        sim_IV2_re1 = paste0("BonferroniƫվܡG", sim_IV2_la1, sim_IV2_sma2)
      }
    }
    sim_IV2_re2 = c(sim_IV2_re, sim_IV2_re1) 
  }
}
simIV2a = t(c(1:length(levels(datr$IV2))))
simIV2a1 = to("A", length(levels(datr$IV2)))
colnames(simIV2a) = simIV2a1
sim_IV2_out_re = apply(simIV2a, 2, simple_IV2_re)
sim_IV2_out_re_1 = paste0(sim_IV2_out_re, collapse = "")

###################################################################################
simIV1_a = matrix("", nrow = 1, ncol = 9)
simIV1_a[1,1] = c(paste0(independent_var[2], "b", independent_var[1]))
simIV2_a = matrix("", nrow = 1, ncol = 9)
simIV2_a[1,1] = c(paste0(independent_var[1], "b", independent_var[2]))
colnames(simIV2_a) = c("ܲӷ", "SS", "~tSS", "df", "~tdf",  "F", "p.adj", 
                       "b2", "Bonferroniվƫ")
colnames(sim_IV1_out1) = c("ܲӷ", "SS", "~tSS", "df", "~tdf",  "F", "p.adj", 
                           "b2", "Bonferroniվƫ")
colnames(simIV1_a) = c("ܲӷ", "SS", "~tSS", "df", "~tdf",  "F", "p.adj", 
                       "b2", "Bonferroniվƫ")
colnames(sim_IV2_out1) = c("ܲӷ", "SS", "~tSS", "df", "~tdf",  "F", "p.adj", 
                           "b2", "Bonferroniվƫ")
sim_IV12_out = rbind(simIV1_a, sim_IV1_out1, simIV2_a, sim_IV2_out1)
colnames(sim_IV12_out) = c("ܲӷ", "SS", "~tSS", "df", "~tdf",  "F", "p.adj", 
                       "b2", "Bonferroniվƫ")

#############################################################################################
#IV1DnĪGƫ˩w
kkb = matrix("", nrow = 3, ncol = 1)
colnames(kkb) = c("bonferroniƫ")
IV1_main_out = datr %>%
  pairwise_t_test(
    DPR ~ IV1, paired = TRUE, 
    p.adjust.method = "bonferroni"
  )
if(twR_ano_tab$p[1] > 0.05) {
  main_IV1_out = c("")
  kkb[1 ,1] = c("")
} else {
if(length(levels(datr$IV1)) == 2) {
  IV1_msd = group_by(datr, IV1) %>%
    summarise(
      mean = round(mean(DPR, na.rm = TRUE), 3),
      sd = round(sd(DPR, na.rm = TRUE), 3), .groups = 'drop'
    ) 
  if(twR_ano_tab$p[1] <= 0.05) {
    if (IV1_msd$mean[1] - IV1_msd$mean[2] > 0) {
      main_IV1_out = paste0(independent_var[1], "O", IV1_msd$IV1[1], "ۦaj", 
                            independent_var[1], "O", IV1_msd$IV1[2], "C")
      kkb[1 ,1] = paste0(IV1_msd$IV1[1], " > ", IV1_msd$IV1[2])
    }
    if (IV1_msd$mean[1] - IV1_msd$mean[2] < 0) {
      main_IV1_out = paste0(independent_var[1], "O", IV1_msd$IV1[1], "ۦaj", 
                          independent_var[1], "O", IV1_msd$IV1[2], "C")
      kkb[1 ,1] = paste0(IV1_msd$IV1[2], " > ", IV1_msd$IV1[1])
    }
  } 
} 
}
if(length(levels(datr$IV1)) >= 3) {
  main_IV1_large   = IV1_main_out %>% filter(p.adj <= 0.05 & statistic > 0)
  main_IV1_sm      = IV1_main_out %>% filter(p.adj <= 0.05 & statistic < 0)
  if(nrow(main_IV1_large) == 0 & nrow(main_IV1_sm) == 0) {
    main_IV1_re1 = paste0("BonferroniƫվA̵MSէOۮtC")
    kkb[1 ,1] = c("")
  }
  if(nrow(main_IV1_large) != 0 & nrow(main_IV1_sm) == 0) {
     main_IV1_la1 = paste0("O", main_IV1_large$group1, "b", dependent_var, 
                           "ۦaj", "O", 
                          main_IV1_large$group2, collapse = "F")
     main_IV1_re1 = paste0(main_IV1_la1, "C")
     lap = paste0(main_IV1_large$group1, " > ", main_IV1_large$group2, collapse = "F")
     kkb[1 ,1] = lap
  }  
  if(nrow(main_IV1_large) == 0 & nrow(main_IV1_sm) != 0) {
    main_IV1_sm1 = paste0("O", main_IV1_sm$group2, "b", dependent_var, 
                          "ۦaj", "O", 
                          main_IV1_sm$group1, collapse = "F")
    main_IV1_re1 = paste0(main_IV1_sm1, "C")
    smp = paste0(main_IV1_sm$group2, " > ", main_IV1_sm$group1, collapse = "F")
    kkb[1 ,1] = smp
  } 
  if(nrow(main_IV1_large) != 0 & nrow(main_IV1_sm) != 0) {
    main_IV1_la1 = paste0("O", main_IV1_large$group1, "b", dependent_var, 
                          "ۦaj", "O", 
                          main_IV1_large$group2, collapse = "F")
    main_IV1_sm1 = paste0("O", main_IV1_sm$group2, "b", dependent_var, 
                          "ۦaj", "O", 
                          main_IV1_sm$group1, collapse = "F")
    main_IV1_re1 = paste0(main_IV1_la1, "F", main_IV1_sm1, "C")
    lap = paste0(main_IV1_large$group1, " > ", main_IV1_large$group2, collapse = "F")
    smp = paste0(main_IV1_sm$group2, " > ", main_IV1_sm$group1, collapse = "F")
    kkb[1 ,1] = paste0(lap, "F", smp)
  } 
  post_IV1 = c("gBonferroniƫվ:")
  main_IV1_out = paste0(post_IV1, main_IV1_re1)
 } 
}
#IV2DnĪGƫ˩w
IV2_main_out = datr %>%
  pairwise_t_test(
    DPR ~ IV2, paired = TRUE, 
    p.adjust.method = "bonferroni"
  )

if(twR_ano_tab$p[2] > 0.05) {
  main_IV2_out = c("")
  kkb[2 ,1] = c("")
} else {
  if(length(levels(datr$IV2)) == 2) {
    IV2_msd = group_by(datr, IV2) %>%
      summarise(
        mean = round(mean(DPR, na.rm = TRUE), 3),
        sd = round(sd(DPR, na.rm = TRUE), 3), .groups = 'drop'
      ) 
    
      if (IV2_msd$mean[1] - IV2_msd$mean[2] > 0) {
        main_IV2_out = paste0(independent_var[2], "O", IV2_msd$IV2[1], "ۦaj", 
                              independent_var[2], "O", IV2_msd$IV2[2], "C")
        kkb[2 ,1] = paste0(IV2_msd$IV2[1], " > ", IV2_msd$IV2[2])
      }
      if (IV2_msd$mean[1] - IV2_msd$mean[2] < 0) {
        main_IV2_out = paste0(independent_var[2], "O", IV2_msd$IV2[2], "ۦaj", 
                              independent_var[2], "O", IV2_msd$IV2[1], "C")
        kkb[2 ,1] = paste0(IV2_msd$IV2[2], " > ", IV2_msd$IV2[1])
      }
  }
  
  if(length(levels(datr$IV2)) >= 3) {
    main_IV2_large   = IV2_main_out %>% filter(p.adj <= 0.05 & statistic > 0)
    main_IV2_sm      = IV2_main_out %>% filter(p.adj <= 0.05 & statistic < 0)
    if(nrow(main_IV2_large) == 0 & nrow(main_IV2_sm) == 0) {
      main_IV2_re1 = paste0("̵MSէOۮtC")
      kkb[2 ,1] = c("")
    }
    if(nrow(main_IV2_large) != 0 & nrow(main_IV2_sm) == 0) {
      main_IV2_la1 = paste0(independent_var[2], "O", main_IV2_large$group1, "b", dependent_var, 
                            "ۦaj", independent_var[2], "O", 
                            main_IV2_large$group2, collapse = "F")
      main_IV2_re1 = paste0(main_IV2_la1, "C")
      kkb[2 ,1] = paste0(main_IV2_large$group1, " > ", main_IV2_large$group2, collapse = "F")
    }  
    if(nrow(main_IV2_large) == 0 & nrow(main_IV2_sm) != 0) {
      main_IV2_sm1 = paste0(independent_var[2], "O", main_IV2_sm$group1, "b", dependent_var, 
                            "ۦaj", independent_var[2], "O", 
                            main_IV2_sm$group2, collapse = "F")
      main_IV2_re1 = paste0(main_IV2_sm1, "C")
      kkb[2 ,1] = paste0(main_IV2_sm$group2, " > ", main_IV2_sm$group1, collapse = "F")
   
    } 
    if(nrow(main_IV2_large) != 0 & nrow(main_IV2_sm) != 0) {
      main_IV2_la1 = paste0(independent_var[2], "O", main_IV2_large$group1, "b", dependent_var, 
                            "ۦaj", independent_var[2], "O", 
                            main_IV2_large$group2, collapse = "F")
      main_IV2_sm1 = paste0(independent_var[2], "O", main_IV2_sm$group2, "b", dependent_var, 
                            "ۦaj", independent_var[2], "O", 
                            main_IV2_sm$group1, collapse = "F")
      main_IV2_re1 = paste0(main_IV2_la1, "F", main_IV2_sm1, "C")
      kkla = paste0(main_IV2_large$group1, " > ", main_IV2_large$group2, collapse = "F")
      kksm = paste0(main_IV2_sm$group2, " > ", main_IV2_sm$group1, collapse = "F")
      kkb[2 ,1] = paste0(kkla, kksm)
    }
    post_IV2 = c("gBonferroniƫվ:")
    main_IV2_out = paste0(post_IV2,  main_IV2_re1)
  }
  }
   
  
##############################################################################################
#### GX ########
if(length(levels(datr$IV1)) == 2 & length(levels(datr$IV2)) == 2) {
  twR_out_1 = paste0("HG]l̼ۨ˥ANOVAR", independent_var[1], "P", independent_var[2],
                     "", dependent_var, "ĪGAUӮyzέppAAAAShapiroVWilk`A˩wBBBA",
                     independent_var[1], "P", independent_var[2],
                     "", dependent_var, "ANOVAKnpCCCC")
  Mauch_aa = c("ѩGӦܶOӲէOASMauchly˩wC")
  tw_norm = paste0("ѪBBBoA", tw_norm_re1)
  ano_aa = c("ѪCCCoA")
  twR_out_re = paste0(ano_aa, twR_out_re)
  twR_interpre = paste0(twR_out_1, tw_norm, Mauch_aa, ano_aa, twR_out_re)
  main_ivc  = c("ѩ椬@ήĪGFۤǡAҥH靈۪DnĪGƫRAG:")
  inter_ivc = c("ѩ椬@ήĪGFۤǡAҥH˩w¥DnĪGA¥DnĪG˩wGe{DDDAG:")
  twR_ano_tab1 = cbind(twR_ano_tab, kkb)
  
  if(twR_ano_tab$p[1] > 0.05 & twR_ano_tab$p[2] > 0.05 & twR_ano_tab$p[3] > 0.05) {
    twR_ano_result = list(nmsdr_out1, aa4, twR_ano_tab, 
                          twR_out_1, tw_norm, Mauch_aa, twR_out_re)
    
  } 
  if(twR_ano_tab$p[3] <= 0.05){
    inter_ivc_a = paste0(inter_ivc, sim_IV1_out_re_1, sim_IV2_out_re_1)
    twR_ano_result = list(nmsdr_out1, aa4, twR_ano_tab, twR_out_1, tw_norm, 
                          Mauch_aa, twR_out_re, 
                          sim_IV12_out, inter_ivc_a)
  } else {
    if(twR_ano_tab$p[1] <= 0.05 & twR_ano_tab$p[2] > 0.05) {
      main_IV1_re2_a = paste0(main_ivc, main_IV1_out)
      twR_ano_result = list(nmsdr_out1, aa4, twR_ano_tab1, twR_out_1, tw_norm, Mauch_aa, 
                            twR_out_re, main_IV1_re2_a)
    }
    if(twR_ano_tab$p[1] > 0.05 & twR_ano_tab$p[2] <= 0.05) {
      main_IV2_re2_a = paste0(main_ivc, main_IV2_out)
      twR_ano_result = list(nmsdr_out1, aa4, twR_ano_tab1, twR_out_1, tw_norm, Mauch_aa,
                            twR_out_re, main_IV2_re2_a)
    }
    if(twR_ano_tab$p[1] <= 0.05 & twR_ano_tab$p[2] <= 0.05) {
      main_IV12_re2_a = paste0(main_ivc, main_IV1_out, main_IV2_out)
      twR_ano_result = list(nmsdr_out1, aa4, twR_ano_tab1, twR_out_1, tw_norm, Mauch_aa,
                            twR_out_re, main_IV12_re2_a)
    }  
  } 
  twR_AOV.savecsv = paste0(save_file, ".csv")
  write.list(z = twR_ano_result, file = twR_AOV.savecsv, row.names = F)
  } else {
  twR_out_1 = paste0("HG]l̼ۨ˥ANOVAR", independent_var[1], "P", independent_var[2],
                     "", dependent_var, "ĪGAUӮyzέppAAAAShapiroVWilk`A˩wBBBA",
                     "Mauchlyy˩wpCCCA", independent_var[1], "P", independent_var[2],
                     "", dependent_var, "ANOVAKnpDDDC")
  tw_norm = paste0("ѪBBBoA", tw_norm_re1)
  mau = paste0("ѪCCCoA", Mauch_out)
  ano_aa = c("ѪDDDoA")
  twR_out_re = paste0(ano_aa, twR_out_re)
  twR_interpre = paste0(twR_out_1, tw_norm, mau, ano_aa, twR_out_re)
  main_ivc  = c("ѩ椬@ήĪGFۤǡAҥH靈۪DnĪGƫRAG:")
  inter_ivc = c("ѩ椬@ήĪGFۤǡAҥH˩w¥DnĪGA¥DnĪG˩wGe{DDDAG:")
  twR_ano_tab1 = cbind(twR_ano_tab, kkb)
  
  if(twR_ano_tab$p[1] > 0.05 & twR_ano_tab$p[2] > 0.05 & twR_ano_tab$p[3] > 0.05) {
    twR_ano_result = list(nmsdr_out1, aa4, Mauch_tab, twR_ano_tab, twR_out_1, tw_norm, 
                          mau, twR_out_re)
  } 
  if(twR_ano_tab$p[3] <= 0.05){
    plot_tw = paste0("i椬@ιϦsbAwɮקpngɡA",
                     "ɦWtwR_plot_A.pngHtwR_plot_B.pngC")
    inter_ivc_a = paste0(inter_ivc, sim_IV1_out_re_1, sim_IV2_out_re_1, plot_tw)
    inter_ivc_a1 = paste0(inter_ivc, sim_IV1_out_re_1)
    twR_ano_result = list(nmsdr_out1, aa4, Mauch_tab, twR_ano_tab, twR_out_1, tw_norm, 
                          mau, twR_out_re, sim_IV12_out, inter_ivc_a1, sim_IV2_out_re_1, plot_tw)
  } else {
    if(twR_ano_tab$p[1] <= 0.05 & twR_ano_tab$p[2] > 0.05) {
      main_IV1_re2_a = paste0(main_ivc, main_IV1_out)
      twR_ano_result = list(nmsdr_out1, aa4, Mauch_tab, twR_ano_tab1, twR_out_1, tw_norm, 
                            mau, twR_out_re, main_IV1_re2_a)
    }
    if(twR_ano_tab$p[1] > 0.05 & twR_ano_tab$p[2] <= 0.05) {
      main_IV2_re2_a = paste0(main_ivc, main_IV2_out)
      twR_ano_result = list(nmsdr_out1, aa4, Mauch_tab, twR_ano_tab1, twR_out_1, tw_norm, 
                            mau, twR_out_re, main_IV2_re2_a)
    }
    if(twR_ano_tab$p[1] <= 0.05 & twR_ano_tab$p[2] <= 0.05) {
      main_IV12_re2_a = paste0(main_ivc, main_IV1_out, main_IV2_out)
      twR_ano_result = list(nmsdr_out1, aa4, Mauch_tab, twR_ano_tab1, twR_out_1, tw_norm, 
                            mau, twR_out_re, main_IV12_re2_a)
    } 
   } 
  twR_AOV.savecsv = paste0(save_file, ".csv")
  write.list(z = twR_ano_result, file = twR_AOV.savecsv, row.names = F)
}
##e椬@ι
twR_inter_plot <- 
  datr %>% 
  group_by(IV1, IV2) %>% 
  summarise( = mean(DPR, na.rm = T), .groups = 'drop')
twR_plot_A = ggplot(twR_inter_plot, 
                    aes(x = IV1, y = , 
                        group = IV2)) +
  geom_point(aes(shape = IV2), size = 4) +
  scale_shape(name = independent_var[2]) +
  geom_line(size = 1) +
  xlab(independent_var[1])

twR_plot_B = ggplot(twR_inter_plot, 
                    aes(x = IV2, y = , 
                        group = IV1)) +
  geom_point(aes(shape = IV1), size = 4) +
  scale_shape(name = independent_var[1]) +
  geom_line(size = 1) +
  xlab(independent_var[2]) 

##s
png("twR_plot_A.png")
print(twR_plot_A)
dev.off()

png("twR_plot_B.png")
print(twR_plot_B)
dev.off() 
while (!is.null(dev.list()))  dev.off()
  }
 }
}###### {#############################################
  
  
  
