########## 10.5 G]l̼ۨ˥ ANOVA dһP  ##########
###### 10.5.3 iD R wOܶ (levels)  ######

library(tidyverse)
library(rstatix)
Unit_10_bev_coffin %>%
  group_by(~ , @ئ]) %>% 
  get_summary_stats(ίvD , type = "mean_sd")

Unit_10_bev_coffin$~ = Unit_10_bev_coffin$~ %>%
  ordered(levels = c("ifi ", "@ ", ""))
Unit_10_bev_coffin$@ئ] = Unit_10_bev_coffin$@ئ] %>% 
  ordered(levels = c("50mg", "100mg", "150mg", "200mg"))

###### 10.5.4 ԭzέp ######

library(rstatix)
Unit_10_bev_coffin %>%
  group_by(~ , @ئ]) %>% 
  get_summary_stats(ίvD , type = "mean_sd")

###### 10.5.5 `A˩w ######

library(rstatix)
Unit_10_bev_coffin %>%
  group_by(~ , @ئ]) %>% 
  shapiro_test(ίvD)

library(psych)
Unit_10_bev_coffin %>%
  group_by(~ , @ئ]) %>%
  summarise(skewness = skew(ίvD), kurtosis = kurtosi(ίvD))

###### 10.5.6 y˩w ######

library(rstatix)
twR_ano_re = anova_test(
  data = bev_coffin, dv = ίvD , wid = id,
  within = c(~ , @ئ]), detailed = T, effect.size = "pes")
twR_ano_re

###### 10.5.7 G]l̼ۨ˥ ANOVA ˩w ######

library(rstatix)
get_anova_table(twR_ano_re)

###### 10.5.8 ¥DnĪG˩w ######

library(rstatix)
Unit_10_bev_coffin %>% 
  group_by(@ئ]) %>%
  anova_test(dv = ίvD , wid = ID, within = ~ ) %>% 
  get_anova_table() %>%
  adjust_pvalue(method = "bonferroni")

bev_coffin %>%
  group_by(~) %>%
  pairwise_t_test(ίvD ~ @ئ] , paired = TRUE,
                  p.adjust.method = "bonferroni" )
  
library(rstatix)
Unit_10_bev_coffin %>% group_by( @ئ] ) %>%
  anova_test(dv = ίvD , wid = id, within = ~ , effect.size = "pes") %>%
  get_anova_table() %>% 
  adjust_pvalue(method = "bonferroni") 
  
bev_coffin %>%
  group_by(@ئ]) %>%
  pairwise_t_test(ίvD ~ ~ , paired = TRUE,
                  p.adjust.method = "bonferroni")  
  
###### 10.5.9 椬@ι ######  
  
library(tidyverse)
twR_inter_plot <-
  Unit_10_bev_coffin %>%
  group_by(~ , @ئ]) %>%
  summarise( = mean(ίvD , na.rm = T))
twR_plot_A = ggplot(twR_inter_plot,
                    aes(x = ~ , y =  ,
                        group = @ئ] )) + 
  geom_point(aes(shape = @ئ]), size = 4) +
  scale_shape(name = "@ئ]") + 
  geom_line(size = 1) +
  xlab("~")
twR_plot_A  

twR_plot_B = ggplot(twR_inter_plot,
                    aes(x = @ئ], y = ,
                        group = ~ )) + 
  geom_point(aes(shape = ~ ), size = 4) +
  scale_shape(name = "~") + 
  geom_line(size = 1) +
  xlab("@ئ]")
twR_plot_B
## s
png("twR_plot_A.png")
print(twR_plot_A)
dev.off()
png("twR_plot_B.png")
print(twR_plot_B)
dev.off()

###### 10.5.12 DnĪGƫ˩w ###### 

Unit_10_bev_coffin %>% 
  pairwise_t_test(ίvD ~ ~, paired = TRUE, p.adjust.method = "bonferroni")

Unit_10_bev_coffin %>% 
  pairwise_t_test(ίvD ~ @ئ], paired = TRUE, p.adjust.method = "bonferroni")




