########## 11.6 G]lVX]p ANOVA ҸѻP R ާ@ ##########

library(tidyverse)
dat_press = burnout_1 %>% select("id", "¾", "u@t", "ǥͰD", "aO")

library(tidyverse)
library(rstatix)
dat_press = dat_press %>%
  gather(key = "O", value = "", "u@t", "ǥͰD", "aO") %>% convert_as_factor(id, ¾, O)
dat_press = na.omit(dat_press)

set.seed(1234)
dat_press %>% sample_n_by(¾ , O , size = 1)

###### 11.6.1 ԭzέp ######

dat_press %>%
  group_by(¾, O) %>% 
  get_summary_stats(, type = "mean_sd")

###### 11.6.2 `A˩w ######

dat_press %>%
  group_by(¾, O) %>% 
  shapiro_test()

library(psych)
dat_press %>%
  group_by(¾, O) %>%
  summarise(A = skew(), p = kurtosi())

###### 11.6.3 ˩wܲƦP ######

library(rstatix)
dat_press %>%
  group_by(O) %>% 
  levene_test( ~ factor(¾))

###### 11.6.4 ܲ - @ܼƯx}P ######

library(heplots)
dat_box = burnout_1 %>% select("id", "¾", "u@t", "ǥͰD", "aO")
dat_box = na.omit(dat_box)
boxM(dat_box[,3:5], dat_box$¾)

###### 11.6.5 y˩w ######

library(rstatix)
mix_ano = anova_test(data = dat_press, dv =  , wid = id,between = ¾ , within = O , detailed = T, effect.size = "pes")
mix_ano

###### 11.6.6 G]lVX]p ANOVA ˩w ######

get_anova_table(mix_ano)

###### 11.6.7 ¥DnĪG˩w ######

dat_press %>%
  group_by(¾) %>%
  anova_test(dv =  , wid = id, within = O,
             detailed = T, effect.size = "pes") %>% 
  get_anova_table() %>%
  adjust_pvalue(method = "bonferroni")

dat_press %>%
  group_by(¾) %>%
  pairwise_t_test( ~ O, paired = TRUE,
                  p.adjust.method = "bonferroni")

dat_press %>%
  group_by(O) %>%
  anova_test(dv =  , wid = id, between = ¾ ,
             detailed = T, type = 3, effect.size = "pes") %>% 
  get_anova_table() %>%
  adjust_pvalue(method = "bonferroni")

dat_press %>%
  group_by(O) %>%
  pairwise_t_test( ~ ¾ , p.adjust.method = "bonferroni")

library(tidyverse)
library(rstatix)
inter_plot = dat_press %>%
  group_by(¾ , O) %>%
  summarise( = mean( , na.rm = T))
plot_A = ggplot(inter_plot, aes(x = ¾ , y =  , group = O)) +
  geom_point(aes(shape = O), size = 4) + 
  scale_shape(name = " O ") + 
  geom_line(size = 1) +
  xlab("¾")
plot_A

plot_B = ggplot(inter_plot, aes(x = O , y =  , group = ¾)) + 
  geom_point(aes(shape = ¾), size = 4) +
  scale_shape(name = "¾") +
  geom_line(size = 1) +
  xlab("O")
plot_B
## s
png("mix_plot_A.png")
print(plot_A)
dev.off()
png("mix_plot_B.png")
print(plot_B)
dev.off()

###### 11.6.10 DnĪGƫ˩w ######

library(car)
leveneTest( ~ ¾, data = dat_press)aov(scores ~ Between, data = dat_m1)

library(DescTools)
PostHocTest(aov( ~ ¾, data = dat_press), method = c("scheffe"))

library(rstatix)
dat_press %>% games_howell_test( ~ ¾)

library(rstatix)
dat_press %>%
  pairwise_t_test( ~ O, paired = TRUE, p.adjust.method = "bonferroni")






