########## 15.5 EFA ҸѻP R ާ@ ##########

library(psych)
des = data.frame(describe(QTI))
des = round(des, 3)
des = rownames_to_column(des, var = "ܶ")
des = des[c(1, 3, 4, 5, 6, 9, 10, 12, 13)]

library(Hmisc)
fac_r = rcorr(as.matrix(QTI))
r = round(data.frame(fac_r$r), 2)
upper1 <- r
upper1[upper.tri(r)]<-""
tl <- as.data.frame(upper1)
write.csv(tl, file = "factor_coreelation.csv", row.names = T)

library(psych)
cortest.bartlett(QTI)
KMO(QTI)

library(nFactors)
eiganvalue = eigen(cor(QTI))
eiganvalue$values

library(psych)
para = fa.parallel(QTI, fa = "pc", main = "Rk")
para$ncomp

library(psych)
EFA <- fa(QTI, nfactors = 5, fm = "pa", rotate = "Promax")
print(EFA, digits=2, cut = 0.30, sort= TRUE)

QTI_D30 = QTI %>% select(-c(D30))
eiganvalue <- eigen(cor(QTI))
eiganvalue$values
EFA <- fa(QTI_D30, nfactors = 5, fm = "pa", rotate = "Promax")
print(EFA, digits=2, cut = 0.30, sort= TRUE)