########## 4.1 ggplot2 Mø² ##########

install.packages("ggplot2")
library(ggplot2)
library(tidyverse)

########## 4.2 򥻨BJ: ggplot() ǳƵe ##########

ggplot(data = elem, aes(x = axJ, y = ƾ))

ggplot(data = elem, aes(x = axJ))

########## 4.3  ##########

fa_bar = ggplot(data = elem, aes(x = axJ ))
fa_bar + geom_bar()

ggplot(data = elem, aes(x = axJ )) + 
  geom_bar() ## T
ggplot(data = elem, aes(x = axJ )) 
+ geom_bar() ## ~
##~ : Cannot use `+.gg()` with a single argument. Did you accidentally put + on a new line?
##Run `rlang :last_error()` to see where the error occurred.

elem$axJ = factor(elem$axJ, levels = c(" @UHU "," @U~ TU ",
                      " TU~U ", " U~KU ", " KU~QU ", " QUHW "))
fa_bar = ggplot(data = elem, aes(x = axJ))
fa_bar + geom_bar()

fa_bar + geom_bar(fill = "steel blue") + 
  labs(x= " JO ", y = "  ", title = "  1 axJ ", subtitle= "  :  ", 
       caption = " ƨӷ : έpǱЧ ") +
  theme(axis.title.x = element_text(colour = "green", size = 14, hjust = 0.5),
        axis.title.y = element_text(colour = "salmon", size = 14, vjust = 0.5), 
        plot.title = element_text(face= "bold", colour = "purple", size = 18, hjust = 0.5),
        plot.subtitle = element_text(face = "italic", colour = "blue", size = 14, hjust = 0.0),
        plot.caption = element_text(face= "bold", colour = "black", size = 14, hjust = 0.0)) +
  theme(axis.text.x = element_text(angle = 45, vjust = 0.5)) + 
  stat_count(geom = "text", colour = "white", size = 3.5, aes(label = ..count..), position = position_stack(vjust = 0.5))

fa_bar = ggplot(data = elem, aes(x = axJ , fill = ʧO ))
fa_bar + geom_bar()

fa_bar + geom_bar(position = "dodge")

########## 4.4  ##########

pie_chart = function(p){
  library(DescTools)
  x = na.omit(p)
  pie.chart = data.frame(Freq(x, ord="desc"))
  ggplot(pie.chart, aes(x = "", y = freq, fill = level)) + 
    geom_bar(width = 1, stat = "identity") + 
    coord_polar("y", start=0) +
    geom_text(aes(label = paste0(round(perc*100), "%")),
              position = position_stack(vjust = 0.5), color = "white")
  }
pie_chart(elem$ axJ )

########## 4.5  ##########

ggplot(data = elem, aes(x=  )) + 
  geom_histogram(fill='red', col='blue')

ggplot(data = elem, aes(x=  )) + 
  geom_histogram(fill='red', col='blue', bins=10)

ggplot(data = elem, aes(x=  )) + 
  geom_histogram(fill='red', col='blue', binwidth = 5)

ggplot(data = elem, aes(x=, fill = ʧO)) + 
  geom_histogram(binwidth = 5)

ggplot(data = elem, aes(x=, fill = ʧO)) + 
  geom_histogram(binwidth = 5, position = "dodge")

########## 4.6 Ž ##########

ggplot(elem, aes(y =  )) + 
  geom_boxplot(color = "red", outlier.colour = "blue", outlier.shape = 8, outlier.size = 4)

ggplot(elem, aes(x = ʧO , y =  )) + 
  geom_boxplot(color = "blue", outlier.colour="red", outlier.shape=8, outlier.size=4)

ggplot(elem, aes(x = ʧO , y =  )) + 
  geom_boxplot(color = "blue", outlier.colour="red", outlier.shape=8, outlier.size=4, notch=TRUE) + 
  coord_flip()

########## 4.7  ##########

ggplot(elem, aes(x =  , y = ƾ )) + 
  geom_point(color = "steel blue", size = 2)

ggplot(elem, aes(x =  , y = ƾ )) +
  geom_point(color = "steel blue") +
  xlab("  ") + ylab(" ƾǤ ") +
  ggtitle("  1 yƻPƾǤƴ ") +
  theme(plot.title = element_text(color = "blue", size = 12)) + 
  theme(axis.title = element_text(color = "blue", size=12)) + 
  theme(axis.line = element_line(colour = "black", size = 1)) + 
  scale_x_continuous(breaks = seq(0, 100, by = 5))

library(ggpubr)
ggplot(elem, aes(x =  , y = ƾ )) +
  geom_point(color = "steel blue") +
  xlab('  ') + ylab(' ƾǤ ') +
  ggtitle("  1 yƻPƾǤƴ ") + 
  theme(plot.title=element_text(color = 'blue', size = 12)) + 
  theme(axis.title=element_text(color='blue', size=12,)) + 
  theme(axis.line = element_line(colour="black", size = 1)) + 
  scale_x_continuous(breaks=seq(0, 100, by = 10)) +
  stat_cor(method = "pearson", label.x = 60, label.y = 90, color="red")

ggplot(elem, aes(x =  , y = ƾ )) + 
  geom_point(color = "steel blue") +
  xlab('  ') + ylab(' ƾǤ ') + 
  ggtitle("  1 yƻPƾǤ  ") +
  theme(plot.title=element_text(color = 'blue', size = 12)) + 
  theme(axis.title=element_text(color='blue', size=12,)) + 
  theme(axis.line = element_line(colour="black", size = 1)) +
  scale_x_continuous(breaks=seq(0, 100, by = 10)) + 
  geom_smooth(method = 'lm', formula = y~x, se = FALSE, color = 'red')

library(ggpmisc)
ggplot(elem, aes(x =  , y = ƾ )) + 
  geom_point(color = "steel blue") +
  labs( x="  ", y=" ƾǤ ",
        title="  1 yƻPƾǤƴ ", subtitle=" uOjkͶսu ", caption=" ƨӷ :Ш|έpҸ " ) +
  theme(plot.title=element_text(color = 'blue', size = 12)) + 
  theme(axis.title=element_text(color='blue', size=12,)) + 
  theme(axis.line = element_line(colour="black", size = 1)) +
  scale_x_continuous(breaks=seq(0, 100, by = 10)) + 
  geom_smooth(method = 'lm', formula = y~x, se = FALSE, color='red') +
  stat_poly_eq(formula = elem$ ƾ ~ elem$  , eq.with.lhs = "italic(hat(y))~`=`~",
               aes(label = paste(..eq.label.., ..rr.label.., sep = "*plain (\",\")~")),
               parse = TRUE)  

########## 4.8 u ##########

ggplot(Happiness, aes(x=year, y= ּ֫ , color= country)) + 
  geom_line(aes(linetype = country)) + 
  scale_x_continuous(breaks=seq(2010, 2017, by = 1))

########## 4.9 xsϤ ##########

png("ּ֫.png")
ggplot(Happiness, aes(x = year, y = ּ֫, color = country)) +
  geom_line(aes(linetype = country)) +
  scale_x_continuous(breaks=seq(2010, 2017, by = 1))
dev.off()

ּ֫ = ggplot(Happiness, aes(x = year, y = ּ֫, color = country)) + 
  geom_line(aes(linetype = country)) + 
  scale_x_continuous(breaks=seq(2010, 2017, by = 1))
png("ּ֫.png")
print(ּ֫)
dev.off()











###### 5.3.1Z ######