######    Two way mixed design ANOVA G]lVX]pANOVA  ###############
#жgƦW
data = burnout_1
#жgնܶW
Between_subjects_var = c("¾")
#жgդܶW
Within_subjects_var = c("u@t", "ǥͰD", "aO")
#жgդܶ@PW
Within_name = c("O")
#жgidW١]ƬOΨ䥦W٧@idW١AжJӦW١^
id_var = c("id")
#жgnXGɮצWr
save_file = c("mix_test")
#########################################################################
library(tidyverse)
library(rstatix)
library(lessR)
library(rlist)
library(erer)
library(DescTools)
library(car)
library(heplots)
library(psych)
library(gmodels)
library(writexl)
##############################################################################
dat_m = dplyr::select(data, all_of(id_var), all_of(Between_subjects_var), 
                      all_of(Within_subjects_var))
dat_m = na.omit(dat_m)
dat_m1 <- dat_m %>%
  gather(key = "Within", value = "scores", all_of(Within_subjects_var)) 
  colnames(dat_m1) = c("id", "Between", "Within", "scores")
dat_m1$id = as.factor(dat_m1$id)
dat_m1$Between = as.factor(dat_m1$Between)
dat_m1$Within  = as.factor(dat_m1$Within)
##############################################################################
if(!is.numeric(dat_m1$scores)){
  AB_output = c("ܶOƭܶALkG]lVX]pܲƤRC")
  AB_output = data.frame(AB_output)
  colnames(AB_output) = c("ĵi")
  cat("ĵiGܶOƭܶALkG]lVX]pܲƤRC")
  AB_outcsv = paste0(save_file, ".xlsx")
  write_xlsx(AB_output, AB_outcsv)
} else {
  if(length(unique(dat_m1$scores)) == 1){
    AB1_output = c("ܶu@ӼƭȡALkG]lVX]pܲƤRC")
    AB1_output = data.frame(AB1_output)
    colnames(AB1_output) = c("ĵi")
    cat("ĵiGܶu@ӼƭȡALkG]lVX]pܲƤRC")
    AB1_outcsv = paste0(save_file, ".xlsx")
    write_xlsx(AB1_output, AB1_outcsv)  
  }
  if(length(unique(dat_m1$scores)) == 2){
    AB2_output = c("ܶuGӼƭȡAAXG]lVX]pܲƤRC")
    AB2_output = data.frame(AB2_output)
    colnames(AB2_output) = c("ĵi")
    cat("ĵiGܶuGӼƭȡAAXG]lVX]pܲƤRC")
    AB2_outcsv = paste0(save_file, ".xlsx")
    write_xlsx(AB2_output, AB2_outcsv) 
  } else {

check_0 = table(dat_m1$Between, dat_m1$Within)

if (any(check_0 == 0 | any(check_0 == 1))) {
  
  c_tab = CrossTable(dat_m1$Between, dat_m1$Within, prop.r = F, prop.c = F,
                     prop.t = F, prop.chisq = F)
  check_0_1 = data.frame(matrix(c_tab$t, nrow = length(unique(dat_m1$Between))))
  rown = levels(dat_m1$Between)
  check_0_1 = cbind(rown, check_0_1)
  colnames(check_0_1) = c("ܶէO", levels(dat_m1$Within))
  tw_ano_result = paste0("ӦܶeӮ椤tƬO01ӮALkG]lVX]pܲƤRC",
                         "аѨ椤ƤtAШϥΦXO覡ӸѨM@DC")
  tw_ano_result = data.frame(tw_ano_result)
  tw_ano = list(tw_ano_result, check_0_1)
  mix_AOV.savecsv = paste0(save_file, ".csv")
  write.list(z = tw_ano, file = mix_AOV.savecsv, row.names = F)
  cat("ĵi:ӦܶeӮ椤tƬ01ӮALkϥΤG]lVX]pܲƤRC") 

  } else {
  
  if(length(unique(dat_m1$Between)) == 1 | length(unique(dat_m1$Within)) == 1) {
    B1_output = data.frame(c("ܶOu1ALkG]lVX]pܲƤRC"))
    colnames(B1_output) = c("ĵi")
    cat("ĵiGܶOu1ALkG]lVX]pܲƤRC")
    B1_outcsv = paste0(save_file, ".xlsx")
    write_xlsx(B1_output, B1_outcsv)
    
  } else {
    dat1 = dat_m1
    norm_tw  = dat1 %>%  group_by(Between, Within) %>% shapiro_test(scores)
    
    norm_tw  = data.frame(norm_tw)
    skew_kur = dat1 %>% group_by(Between, Within) %>%
      summarise(skew = skew(scores), kurtosis = kurtosi(scores), .groups = 'drop')
    skew_kur = data.frame(skew_kur)
    aa1 = norm_tw[ ,1:2]
    aa2 = round(norm_tw[ ,4:5], 3)
    aa3 = round(skew_kur[ ,3:4], 3)
    aa4 = cbind(aa1, aa2, aa3)
    colnames(aa4) = c(Between_subjects_var, Within_name, 
                      "ShapiroVWilkέpq", "p", "A", "p׭")
    
    norm_fa = function(iiz) {
      if (norm_tw$p[iiz] > 0.05) {
        norm_out = paste0("u",  Between_subjects_var, "էO", norm_tw$Between[iiz], "P", norm_tw$Within[iiz], "vsժShapiroVWilkέpq = ", 
                          round(norm_tw$statistic[iiz], 3),  "Ap = ", round(norm_tw$p[iiz], 3), 
                          " > 0.05Aܦsժ`AʰwߡC")
      } else {
        norm_1 = paste0("u", Between_subjects_var, "էO", norm_tw$Between[iiz], "P", norm_tw$Within[iiz], "vsժShapiroVWilkέpq = ", 
                        round(norm_tw$statistic[iiz], 3),  "Ap = ", round(norm_tw$p[iiz], 3), 
                        " < 0.05 Ai@B˩wsժAȻPp׭ȡC")
        if(abs(skew_kur$skew[iiz]) >= 3) { 
          norm_ske = paste0("A = ", round(skew_kur$skew[iiz], 3), "A  3AܦYA{HC")
        } else {
          norm_ske = paste0("A = ", round(skew_kur$skew[iiz], 3), "A < 3AܨSYA{HC")  
        }
        
        if(abs(skew_kur$kurtosis[iiz]) >= 10) { 
          norm_kur = paste0("p׭ = ", round(skew_kur$kurtosis[iiz], 3), "A  10AܦYL󥭩Zΰ~k{HC")
        } else {
          norm_kur = paste0("p׭ = ", round(skew_kur$kurtosis[iiz], 3), "A < 10AܨSYL󥭩Zΰ~k{HC")  
        }
        if(abs(skew_kur$skew[iiz]) >= 3 & abs(skew_kur$kurtosis[iiz]) >= 10) {
          norm_out = paste0(norm_1, norm_ske, norm_kur, "ѩShapiroVWilk`A˩wܫD`AA",
                            "BAܦYA{HAp׭ܦYL󥭩Zΰ~k{HA",
                            "]iHPw@sYHϱ`AʡC",
                            "(Ū̥iѦҡu11.4G]lVX]pANOVAwv@p`AMDѨM覡C)")
        }
        if(abs(skew_kur$skew[iiz]) >= 3) {
          norm_out = paste0(norm_1, norm_ske, norm_kur, "ѩShapiroVWilk`A˩wܫD`AA",
                            "BAܦYA{HA]iHPwHϱ`AʡC", 
                            "(Ū̥iѦҡu11.4G]lVX]pANOVAwv@p`AMDѨM覡C)")
        }
        
        if(abs(skew_kur$kurtosis[iiz]) >= 10) {
          norm_out = paste0(norm_1, norm_ske, norm_kur, "ѩShapiroVWilk`A˩wܫD`AA",
                            "Bp׭ܦYL󥭩Zΰ~k{HA]iHPwHϱ`AʡC", 
                            "(Ū̥iѦҡu11.4G]lVX]pANOVAwv@p`AMDѨM覡C)")
        }
        
        if(abs(skew_kur$skew[iiz]) < 3 & abs(skew_kur$kurtosis[iiz]) < 10) {
          norm_out = paste0(norm_1, norm_ske, norm_kur, "MShapiroVWilk`A˩wܫD`A", 
                            "AMӰAܨSYA{HAp׭ܨSYL󥭩Zΰ~k{HA",
                            "@sեiHΩG]lVX]pANOVA˩wC" )
        }
      }
    } 
    
    kla = length(unique(dat_m1$Between))*length(unique(dat_m1$Within))
    kha = t(c(1:kla))
    kh1a = to("iiz", kla)
    colnames(kha) = kh1a
    mix_norm_re = apply(kha, 2, norm_fa)
    mix_norm_re1 = paste0(mix_norm_re, collapse = "")
    
################################################################################    
nmixr_f = function(qq){
  datr_mix = dat_m1
  datr_km = datr_mix[datr_mix$Between == qq, ]
  d = tapply(datr_km$scores, datr_km$Within,
             function(x) format(describe(x)))
  d1 = list.rbind(d)
  d2 = d1[ ,c(2, 3, 4)]
  d3 = round(as.numeric(unlist(d2)), 3)
  d4 = matrix(d3, nrow = length(unique(datr_km$Within)))
  colnames(d4) = c("N", "", "зǮt")
  d5 = t(d4)
  d6 = c("N", "", "зǮt")
  d7 = cbind(d6, d5)
  jkla = paste0(Between_subjects_var, "էO", qq)
  d8 = c(jkla, "", "")
  d9 = cbind(d8, d7)
  d10 = data.frame(d9)
}
nmixr1 = t(c(levels(dat_m1$Between)))
nmixr11 = to("qq", length(levels(dat_m1$Between)))
colnames(nmixr1) = nmixr11
nmixr_out = apply(nmixr1, 2, nmixr_f)
nmixr_out1 = list.rbind(nmixr_out)
nmixr_out1 = data.frame(nmixr_out1)
colnames(nmixr_out1) = c("ܶէO", "ԭzέp", levels(dat_m1$Within))
nmixr_out1

##############################################################################
#ܲƦP˩w
mix_levene = dat_m1 %>%
  group_by(Within) %>%
  levene_test(scores ~ factor(Between))
mix_levene$statistic = round(mix_levene$statistic, 3)
mix_le1 = mix_levene
lev_b = rep(Between_subjects_var, length(Within_subjects_var))
mix_le = cbind(lev_b, mix_le1)
colnames(mix_le) = c("նܶ", "դܶ", "df1", "df2", "F", "p")

mix_le_f = function(le){
if (mix_levene$p[1] >= 0.05) {
  mix_leven_re = paste0(Between_subjects_var, "b", mix_levene$Within[le], "LevenܲƦP˩wܡAF = ", 
                        mix_levene$statistic[le], "Ap > 0.05AܲƬ۵ߡC")
} else {
  mix_leven_re = paste0(Between_subjects_var, "b", mix_levene$Within[le], "LevenܲƦP˩wܡAF = ", 
                        mix_levene$statistic[le], "Ap < 0.05AܲƬ۵ߡC")
}
  mix_leven_re1 =  mix_leven_re
}
le = t(c(1:length(mix_le$p)))
le1 = to("le", length(mix_le$p))
colnames(le) = le1
mix_leven_out = apply(le, 2, mix_le_f)
mix_leven_out1 = paste0(mix_leven_out, collapse = "")
mix_leven_out1
#Box's M@ܼƯx}

dat_m2 = dat_m
colnames(dat_m2) = c("id", "Between", Within_subjects_var)
mix_box1 = boxM(dat_m2[,3:length(dat_m2)], dat_m2$Between)
mix_box = cbind(mix_box1$statistic, mix_box1$p.value)
colnames(mix_box) = c("Box_Mέpq", "p")
mix_box = data.frame(mix_box)
mix_box$Box_Mέpq = round(mix_box$Box_Mέpq, 3)
if(mix_box$p > 0.001) {
  mix_box_out = paste0("Boxs M˩wܡA", "Box's Mέpq = ", mix_box$Box_Mέpq[1],
                       "Ap = ", round(mix_box$p, 3), " > 0.001Aܲ-@ܼƦPʰ]ߡC")
} else {
  mix_box_out = paste0("Boxs M˩wܡA", "Box's Mέpq = ", mix_box$Box_Mέpq[1],
                       "Ap = ", round(mix_box$p, 3), " < 0.001Aܲ-@ܼƦPʰ]ߡC椬@ζ˩w|tC")
}
mix_box_out

#y˩w###########################################################################

if(length(unique(dat_m1$Within)) == 2) {
  mix_Mau_out1 = c("դܶuաALMauchly˩wC")
  mix_Mauch = c("դܶuաASMauchly˩wC")
} else {
mix_phe = anova_test(
  data = dat_m1, dv = scores, wid = id,
  between = Between, within = Within, 
  detailed = T, type = 3, effect.size = "pes"
)
mix_Mauch = mix_phe$`Mauchly's Test for Sphericity`[ ,1:3]

mix_ab = paste0(Between_subjects_var, ":", Within_name)
mix_Mauch$Effect = c(Within_name, mix_ab)
colnames(mix_Mauch) = c("ĪG", "Mauchly's W", "p")
mix_Mauch$p = round(mix_Mauch$p, 5)

if(mix_Mauch$p[1] <= 0.05) {
  mix_Mau_B1 = paste0(mix_Mauch$ĪG[1], "Mauchly˩wMauchly's W = ", 
                     mix_Mauch$`Mauchly's W`[1], "Ap < 0.05AywߡA",
                     "ϥGreenhouse-Geisser (GG)󥿪έppȨ˩w۩ʡC") 
} else {
  mix_Mau_B1 = paste0(mix_Mauch$ĪG[1], "Mauchly˩wMauchly's W = ", 
                     mix_Mauch$`Mauchly's W`[1], "Ap > 0.05AywߡC" ) 
  
}
if(mix_Mauch$p[2] <= 0.05) {
  mix_Mau_AB = paste0(mix_Mauch$ĪG[2], "Mauchly˩wMauchly's W = ", 
                      mix_Mauch$`Mauchly's W`[2], "Ap < 0.05AywߡA",
                        "ϥGreenhouse-Geisser (GG)󥿪έppȨ˩w۩ʡC" ) 
} else {
  mix_Mau_AB = paste0(mix_Mauch$ĪG[2], "Mauchly˩wMauchly's W = ", 
                      mix_Mauch$`Mauchly's W`[2], "Ap > 0.05AywߡC" ) 
  
}

mix_Mau_out1 = paste0(mix_Mau_B1, mix_Mau_AB)
}
##############################################################################
mix_ano = anova_test(
  data = dat_m1, dv = scores, wid = id,
  between = Between, within = Within, 
  detailed = T, type = 3, effect.size = "pes"
)
mix_ano_1 = get_anova_table(mix_ano)
mix_ano_1$p = round(mix_ano_1$p, 5)
mix_ano_tab = data.frame(mix_ano_1) %>% select(c(1, 4, 5, 2, 3, 6, 7, 9))
mix_ano_tab = mix_ano_tab[-1, ]
mix_var_1 = paste0(Between_subjects_var, ":", Within_name)
mix_ano_tab$Effect = c(Between_subjects_var, Within_name, mix_var_1)
colnames(mix_ano_tab) = c("ܲӷ", "SS", "~tSS", "df", "~tdf",  "F", "p", "b2") 

if(mix_ano_tab$p[1] > 0.05) {
  mix_main_A1 = paste0(mix_ano_tab$ܲӷ[1], "bܶ", Within_name, "ƤWSۥDnĪGAF(",
                      mix_ano_tab$df[1], ", ", mix_ano_tab$~tdf[1], ") = ",  
                      mix_ano_tab$F[1], "Ap = ", mix_ano_tab$p[1], " > 0.05", "Ab2 = ", 
                      mix_ano_tab$b2[1], "C")
} else {
  if(mix_ano_tab$p[1] <= 0.05 & mix_ano_tab$p[1] > 0.01){
    ps = c(" < 0.05")
  }
  if(mix_ano_tab$p[1] <= 0.01 & mix_ano_tab$p[1] > 0.001){
    ps = c(" < 0.01")
  }
  if(mix_ano_tab$p[1] <= 0.001){
    ps = c(" < 0.001")
  }
  mix_main_A1 = paste0(mix_ano_tab$ܲӷ[1], "bܶ", Within_name, "ƤWۥDnĪGAF(",
                      mix_ano_tab$df[1], ", ", mix_ano_tab$~tdf[1], ") = ",  
                      mix_ano_tab$F[1], "Ap = ", mix_ano_tab$p[1], ps, "Ab2 = ", 
                      mix_ano_tab$b2[1], "C")
}

if(mix_ano_tab$p[2] > 0.05) {
  mix_main_B1 = paste0(mix_ano_tab$ܲӷ[2], "bܶ", Within_name, "ƤWSۥDnĪGAF(",
                      mix_ano_tab$df[2], ", ", mix_ano_tab$~tdf[2], ") = ",  
                      mix_ano_tab$F[2], "Ap = ", mix_ano_tab$p[2], " > 0.05", "Ab2 = ", 
                      mix_ano_tab$b2[2], "C")
} else {
  if(mix_ano_tab$p[2] <= 0.05 & mix_ano_tab$p[2] > 0.01){
    ps1 = c(" < 0.05")
  }
  if(mix_ano_tab$p[2] <= 0.01 & mix_ano_tab$p[2] > 0.001){
    ps1 = c(" < 0.01")
  }
  if(mix_ano_tab$p[2] <= 0.001){
    ps1 = c(" < 0.001")
  }
  mix_main_B1 = paste0(mix_ano_tab$ܲӷ[2], "bܶ", Within_name, "ƤWۥDnĪGAF(",
                      mix_ano_tab$df[2], ", ", mix_ano_tab$~tdf[2], ") = ",  
                      mix_ano_tab$F[2], "Ap = ", mix_ano_tab$p[2], ps1, "Ab2 = ", 
                      mix_ano_tab$b2[2], "C")
}

if(mix_ano_tab$p[3] > 0.05) {
  mix_main_AB = paste0(mix_ano_tab$ܲӷ[1], "P", mix_ano_tab$ܲӷ[2], "bܶ", Within_name,
                       "ƤWS椬@ήĪGA", "F(", mix_ano_tab$df[3], ", ", mix_ano_tab$~tdf[3], ") = ",  
                       mix_ano_tab$F[3], "Ap = ", mix_ano_tab$p[3], " > 0.05", "Ab2 = ", 
                       mix_ano_tab$b2[3], "C")
} else {
  if(mix_ano_tab$p[3] <= 0.05 & mix_ano_tab$p[3] > 0.01){
    ps2 = c(" < 0.05")
  }
  if(mix_ano_tab$p[3] <= 0.01 & mix_ano_tab$p[3] > 0.001){
    ps2 = c(" < 0.01")
  }
  if(mix_ano_tab$p[2] <= 0.001){
    ps2 = c(" < 0.001")
  }
  mix_main_AB = paste0(mix_ano_tab$ܲӷ[1], "P", mix_ano_tab$ܲӷ[2], "bܶ", Within_name,
                       "ƤW椬@ήĪGA", "F(", mix_ano_tab$df[3], ", ", mix_ano_tab$~tdf[3], ") = ",  
                       mix_ano_tab$F[3], "Ap = ", mix_ano_tab$p[3], ps2, "Ab2 = ", 
                       mix_ano_tab$b2[3], "C")
}
mix_out_re = paste0(mix_main_A1, mix_main_B1, mix_main_AB)

####################################################################################
#椬@ζ۪¥DnĪG
#Between¥DnĪG
mix_sim_A1 = dat_m1 %>%
  group_by(Between) %>%
  anova_test(dv = scores, wid = id, within = Within, 
             detailed = T, type = 3, effect.size = "pes") %>%
  get_anova_table() %>%
  adjust_pvalue(method = "bonferroni")
mix_sim_A1 = data.frame(mix_sim_A1) %>% filter(Effect == "Within")
# Between¥DnĪGƫ˩w
mix_sim_post_A1 = dat_m1 %>%
  group_by(Between) %>%
  pairwise_t_test(scores ~  Within, paired = TRUE, pool.sd = FALSE, 
                  p.adjust.method = "bonferroni")
# Between¥DnĪG
mix_A1_f =  function(mixA1) {
    mix_sim_A1 = data.frame(mix_sim_A1)
    mix_post_A1 = mix_sim_A1 %>%
    filter(Between == levels(dat_m1$Between)[mixA1])
  
 if(mix_post_A1$p.adj > 0.05) {
   mix_A1_sim = c("")
  } else {
    
 if(length(levels(dat_m1$Within)) == 2) {
    A1_mix_sim_post = mix_sim_post_A1 %>% filter(Between == levels(dat_m1$Between)[mixA1])
   if(mix_post_A1$p.adj <= 0.05 & A1_mix_sim_post$statistic > 0) {
      mix_A1_sim = paste0(A1_mix_sim_post$group1, " > ", A1_mix_sim_post$group2, collapse = "F")
    }
    if(mix_post_A1$p.adj <= 0.05 & A1_mix_sim_post$statistic < 0) {
      mix_A1_sim = paste0(A1_mix_sim_post$group2, " > ", A1_mix_sim_post$group1, collapse = "F")
    }
    if(mix_post_A1$p.adj > 0.05) {
      mix_A1_sim = c("")
    }
 }
  if(length(levels(dat_m1$Within)) >= 3) {
  mix_A1_lar = mix_sim_post_A1 %>%
    filter(Between == levels(dat_m1$Between)[mixA1] & statistic > 0 & p.adj <= 0.05)
  mix_A1_sm = mix_sim_post_A1 %>%
    filter(Between == levels(dat_m1$Between)[mixA1] & statistic < 0 & p.adj <= 0.05)
  if(nrow(mix_A1_lar) == 0 & nrow(mix_A1_sm) == 0) {
    mix_A1_sim = c("")
  }
  if(nrow(mix_A1_lar) != 0 & nrow(mix_A1_sm) == 0) {
    mix_A1_sim = paste0(mix_A1_lar$group1, " > ", mix_A1_lar$group2, collapse = "F")
  }  
  if(nrow(mix_A1_lar) == 0 & nrow(mix_A1_sm) != 0) {
    mix_A1_sim = paste0(mix_A1_sm$group2,  " > ", mix_A1_sm$group1, collapse = "F")
  } 
  if(nrow(mix_A1_lar) != 0 & nrow(mix_A1_sm) != 0) {
    mix_A1_a = paste0(mix_A1_lar$group1, " > ", mix_A1_lar$group2, collapse = "F")
    mix_A1_b = paste0(mix_A1_sm$group2,  " > ", mix_A1_sm$group1, collapse = "F")
    mix_A1_sim = paste0(mix_A1_a, "F", mix_A1_b)
  } 
  }
  }
  mix_sim_A1_tab = cbind(mix_post_A1, mix_A1_sim)
  mix_sim_A1_tab$p.adj = round(mix_sim_A1_tab$p.adj, 5)
  mix_sim_A1_tab = mix_sim_A1_tab[ ,c(1, 5, 6, 3, 4, 7, 11, 10, 12)]
  colnames(mix_sim_A1_tab) = c("ܲӷ", "SS",  "~tSS", "df", "~tdf", "F", "p.adj", 
                          "b2", "Bonferroniվƫ")
  mk = paste0(Between_subjects_var, "էO", mix_sim_A1_tab$ܲӷ[[1]])
  mix_sim_A1_tab[ ,1] = mk
  mix_sim_A1_tab1 = mix_sim_A1_tab

}
mixA1 = t(c(1:length(levels(dat_m1$Between))))
mixA11 = to("mA", length(levels(dat_m1$Between)))
colnames(mixA1) = mixA11
mix_sim_A1_out = apply(mixA1, 2, mix_A1_f)
mix_sim_A1_out1 = list.rbind(mix_sim_A1_out)
mix_sim_A1_out1
##¥DnĪGBetweenGi
mix_simple_A1_re =  function(mixA1a) {
  mix_sim_A1 = data.frame(mix_sim_A1)
  mix_post_A1a = mix_sim_A1 %>%
    filter(Between == levels(dat_m1$Between)[mixA1a])
  p_adj = round(mix_post_A1a$p.adj, 5)
  if(mix_post_A1a$p.adj <= 0.05) {
    if(mix_post_A1a$p.adj <= 0.05 & mix_post_A1a$p.adj > 0.01){
      ps3 = c(" < 0.05")
    }
    if(mix_post_A1a$p.adj <= 0.01 & mix_post_A1a$p.adj > 0.001){
      ps3 = c(" < 0.01")
    }
    if(mix_post_A1a$p.adj <= 0.001){
      ps3 = c(" < 0.001")
    }
    
    mix_sim_A1_re = paste0( "", Between_subjects_var, "O", levels(dat_m1$Between)[mixA1a], "ӨA", Within_name,
                      "OƦ۪¥DnĪGAF", "(", mix_post_A1a$DFn, ", ", mix_post_A1a$DFd, ") = ",  
                      mix_post_A1a$F, "Aվp = ", p_adj, ps3, "Ab2 = ", 
                      mix_post_A1a$pes, "C") 
  } else {
    mix_sim_A1_re = paste0( "", Between_subjects_var, "O", levels(dat_m1$Between)[mixA1a], "ӨA", Within_name,
                            "OƨS۪¥DnĪGAF", "(", mix_post_A1a$DFn, ", ", mix_post_A1a$DFd, ") = ",  
                            mix_post_A1a$F, "Aվp = ", p_adj, " > 0.05Ab2 = ", 
                            mix_post_A1a$pes, "C")
  }
  
  if(mix_post_A1a$p.adj > 0.05) {
    mix_sim_A1a_re1 = c("")
  } else {
  
    if(length(levels(dat_m1$Within)) == 2) {
      A1_mix_sim_post = mix_sim_post_A1 %>% filter(Between == levels(dat_m1$Between)[mixA1a])
    if(mix_post_A1a$p.adj[1] <= 0.05 & A1_mix_sim_post$statistic > 0) {
      A1k1 = paste0(Within_name, "O", A1_mix_sim_post$group1, "ۦaj", 
                    Within_name, "O", A1_mix_sim_post$group2, "C")
      mix_sim_A1a_re1 = paste0("BonferroniƫվܡG", A1k1)
      
    }
    if(mix_post_A1a$p.adj[1] <= 0.05 & A1_mix_sim_post$statistic < 0) {
      A1k2 = paste0(Within_name, "O", A1_mix_sim_post$group2, "ۦaj", 
                    Within_name, "O", A1_mix_sim_post$group1, "C")
      mix_sim_A1a_re1 = paste0("BonferroniƫվܡG", A1k2)
    }
      }
  
  if(length(levels(dat_m1$Within)) >= 3) { 
  mix_A1_lara = mix_sim_post_A1 %>%
    filter(Between == levels(dat_m1$Between)[mixA1a] & statistic > 0 & p.adj <= 0.05)
  mix_A1_sma = mix_sim_post_A1 %>%
    filter(Between == levels(dat_m1$Between)[mixA1a] & statistic < 0 & p.adj <= 0.05)
  if(nrow(mix_A1_lara) == 0 & nrow(mix_A1_sma) == 0) {
    mix_sim_A1a_re1 = c("")
  }
  if(nrow(mix_A1_lara) != 0 & nrow(mix_A1_sma) == 0) {
    mix_sim_A1a_la = paste0(Within_name, "O", mix_A1_lara$group1, "ۦaj", Within_name, "O", mix_A1_lara$group2, "C")
    mix_sim_A1a_la1 = paste0(mix_sim_A1a_la, collapse = "" )
    A1k = paste0("", Between_subjects_var, "O", levels(dat_m1$Between)[mixA1a], "ӨA")
    mix_sim_A1a_re1 = paste0("BonferroniƫվܡG", A1k, mix_sim_A1a_la1)
  }  
  if(nrow(mix_A1_lara) == 0 & nrow(mix_A1_sma) != 0) {
    mix_sim_A1a_sm = paste0(Within_name, "O", mix_A1_sma$group2, "ۦaj", Within_name, "O", 
                       mix_A1_sma$group1, "C")
    mix_sim_A1a_sm1 = paste0(mix_sim_A1a_sm, collapse = "" )
    A1k = paste0("", Between_subjects_var, "O", levels(dat_m1$Between)[mixA1a], "ӨA")
    mix_sim_A1a_re1 = paste0("BonferroniƫվܡG", A1k, mix_sim_A1a_sm1)
  } 
  if(nrow(mix_A1_lara) != 0 & nrow(mix_A1_sma) != 0) {
    mix_sim_A1a_la = paste0(Within_name, "O", mix_A1_lara$group1, "ۦaj", Within_name, "O", mix_A1_lara$group2, "C")
    mix_sim_A1a_la1 = paste0(mix_sim_A1a_la, collapse = "" )
    mix_sim_A1a_sm = paste0(Within_name, "O", mix_A1_sma$group2, "ۦaj", Within_name, "O", 
                           mix_A1_sma$group1, "C")
    mix_sim_A1a_sm1 = paste0(mix_sim_A1a_sm, collapse = "" )
    A1k = paste0("", Between_subjects_var, "O", levels(dat_m1$Between)[mixA1a], "ӨA")
    mix_sim_A1a_re1 = paste0("BonferroniƫվܡG", A1k, mix_sim_A1a_la1, mix_sim_A1a_sm1)
  }
  }
  }
  mix_sim_A1a_re2 = paste0(mix_sim_A1_re, mix_sim_A1a_re1)
  }
mixA1a = t(c(1:length(levels(dat_m1$Between))))
mixA1a1 = to("miA", length(levels(dat_m1$Between)))
colnames(mixA1a) = mixA1a1
mix_sim_A1_out_re = apply(mixA1a, 2, mix_simple_A1_re)
mix_sim_A1_out_re1 = paste0(mix_sim_A1_out_re, collapse = "")
#################################################################################################
# Within¥DnĪG
mix_sim_B1 = dat_m1 %>%
  group_by(Within) %>%
  anova_test(dv = scores, wid = id, between = Between, 
             detailed = T, type = 3, effect.size = "pes") %>%
  get_anova_table() %>%
  adjust_pvalue(method = "bonferroni")

mix_sim_B1 = data.frame(mix_sim_B1) %>% filter(Effect == "Between")
#Within¥DnĪGƫ˩w
mix_sim_post_B1 = dat_m1 %>%
  group_by(Within) %>%
  pairwise_t_test(scores ~ Between, pool.sd = FALSE, 
                  p.adjust.method = "bonferroni")
####################################################################################
# Within¥DnĪG
mix_B1_f =  function(mixB1) {
    mix_post_B1 = data.frame(mix_sim_B1) %>%
    filter(Within == levels(dat_m1$Within)[mixB1])
  if(mix_post_B1$p.adj > 0.05) {
    mix_B1_sim = c("")
  } else {
  if(length(levels(dat_m1$Between)) == 2) {
    B1_mix_sim_post = mix_sim_post_B1 %>% filter(Within == levels(dat_m1$Within)[mixB1])
    if(mix_post_B1$p.adj <= 0.05 & B1_mix_sim_post$statistic > 0) {
      mix_B1_sim = paste0(B1_mix_sim_post$group1, " > ", B1_mix_sim_post$group2, collapse = "F")
    }
    if(mix_post_B1$p.adj <= 0.05 & B1_mix_sim_post$statistic < 0) {
      mix_B1_sim = paste0(B1_mix_sim_post$group2, " > ", B1_mix_sim_post$group1, collapse = "G")
    }
   }
  
  if(length(levels(dat_m1$Between)) >= 3) { 
  mix_B1_lar = mix_sim_post_B1 %>%
    filter(Within == levels(dat_m1$Within)[mixB1] & statistic > 0 & p.adj <= 0.05)
  mix_B1_sm = mix_sim_post_B1 %>%
    filter(Within == levels(dat_m1$Within)[mixB1] & statistic < 0 & p.adj <= 0.05)
  if(nrow(mix_B1_lar) == 0 & nrow(mix_B1_sm) == 0) {
    mix_B1_sim = c("")
  }
  if(nrow(mix_B1_lar) != 0 & nrow(mix_B1_sm) == 0) {
    mix_B1_sim = paste0(mix_B1_lar$group1, " > ", mix_B1_lar$group2, collapse = "F")
  }  
  if(nrow(mix_B1_lar) == 0 & nrow(mix_B1_sm) != 0) {
    mix_B1_sim = paste0(mix_B1_sm$group2, " > ", mix_B1_sm$group1, collapse = "F")
  } 
  if(nrow(mix_B1_lar) != 0 & nrow(mix_B1_sm) != 0) {
    mix_B1_a = paste0(mix_B1_lar$group1, " > ", mix_B1_lar$group2, collapse = "F")
    mix_B1_b = paste0(mix_B1_sm$group2, " > ", mix_B1_sm$group1, collapse = "F")
    mix_B1_sim = paste0(mix_B1_a, "F", mix_B1_b)
  } 
  }
  }
  mix_sim_B1_tab = cbind(mix_post_B1, mix_B1_sim)
  mix_sim_B1_tab$p.adj = round(mix_sim_B1_tab$p.adj, 5)
  mix_sim_B1_tab = mix_sim_B1_tab[ ,c(1, 3, 4, 5, 6, 7, 11, 10, 12)]
  colnames(mix_sim_B1_tab) = c("ܲӷ", "SS",  "~tSS", "df", "~tdf", "F", "p.adj", 
                               "b2", "Bonferroniվƫ")
  mix_sim_B1_tab1 = mix_sim_B1_tab

}
mixB1 = t(c(1:length(levels(dat_m1$Within))))
mixB11 = to("mB", length(levels(dat_m1$Within)))
colnames(mixB1) = mixB11
mix_sim_B1_out = apply(mixB1, 2, mix_B1_f)
mix_sim_B1_out1 = list.rbind(mix_sim_B1_out)
mix_sim_B1_out1
##¥DnĪGWithinGi
mix_simple_B1_re =  function(mixB1a) {
  mix_post_B1a = data.frame(mix_sim_B1) %>%
    filter(Within == levels(dat_m1$Within)[mixB1a])
    p_adj_b = round(mix_post_B1a$p.adj, 5)
  if(mix_post_B1a$p.adj <= 0.05) {
    if(mix_post_B1a$p.adj <= 0.05 & mix_post_B1a$p.adj > 0.01){
      ps4 = c(" < 0.05")
    }
    if(mix_post_B1a$p.adj <= 0.01 & mix_post_B1a$p.adj > 0.001){
      ps4 = c(" < 0.01")
    }
    if(mix_post_B1a$p.adj <= 0.001){
      ps4 = c(" < 0.001")
    }
    mix_sim_B1_re = paste0( "", Within_name, "O", levels(dat_m1$Within)[mixB1a], 
                            "ӨA", Between_subjects_var, "Oo۪¥DnĪGAF", 
                            "(", mix_post_B1a$DFn, ", ", mix_post_B1a$DFd, ") = ",  
                            mix_post_B1a$F, "Aվp = ", p_adj_b, ps4, "Ab2 = ", 
                            mix_post_B1a$pes, "C") 
  } else {
    mix_sim_B1_re = paste0( "", Within_name, "O", levels(dat_m1$Within)[mixB1a], 
                            "ӨA", Between_subjects_var, "OoS۪¥DnĪGAF", 
                            "(", mix_post_B1a$DFn, ", ", mix_post_B1a$DFd, ") = ",  
                            mix_post_B1a$F, "Aվp = ", p_adj_b, " > 0.05Ab2 = ", 
                            mix_post_B1a$pes, "C")
  }
 
if(mix_post_B1a$p.adj > 0.05) {
  mix_sim_B1a_re1 = c("")
  } else { 
  if(length(levels(dat_m1$Between)) == 2) {
    B1_mix_sim_post = mix_sim_post_B1 %>% filter(Within == levels(dat_m1$Within)[mixB1a])
    if(mix_post_B1a$p.adj[1] <= 0.05 & B1_mix_sim_post$statistic > 0) {
      B1k1 = paste0(Between_subjects_var, "O", B1_mix_sim_post$group1, "ۦaj", 
             Between_subjects_var, "O", B1_mix_sim_post$group2, "C")
      mix_sim_B1a_re1 = paste0("BonferroniƫվܡG", B1k1)
    
    }
    if(mix_post_B1a$p.adj[1] <= 0.05 & B1_mix_sim_post$statistic < 0) {
      B1k2 = paste0(Between_subjects_var, "O", B1_mix_sim_post$group2, "ۦaj", 
                    Between_subjects_var, "O", B1_mix_sim_post$group1, "C")
      mix_sim_B1a_re1 = paste0("BonferroniƫվܡG", B1k2)
    }
  }
  
 if(length(levels(dat_m1$Between)) >= 3) {
  mix_B1_lara = mix_sim_post_B1 %>%
    filter(Within == levels(dat_m1$Within)[mixB1a] & statistic > 0 & p.adj <= 0.05)
  mix_B1_sma = mix_sim_post_B1 %>%
    filter(Within == levels(dat_m1$Within)[mixB1a] & statistic < 0 & p.adj <= 0.05)
  if(nrow(mix_B1_lara) == 0 & nrow(mix_B1_sma) == 0) {
    mix_sim_B1a_re1 = paste0("")
  }
  if(nrow(mix_B1_lara) != 0 & nrow(mix_B1_sma) == 0) {
    mix_sim_B1a_la = paste0(Within_name, "O", mix_B1_lara$group1, "ۦaj", Within_name, "O", mix_B1_lara$group2, "C")
    mix_sim_B1a_lB1 = paste0(mix_sim_B1a_la, collapse = "" )
    mix_sim_B1a_re1 = paste0("BonferroniƫվܡG", mix_sim_B1a_lB1)
  }  
  if(nrow(mix_B1_lara) == 0 & nrow(mix_B1_sma) != 0) {
    mix_sim_B1a_sm = paste0(Within_name, "O", mix_B1_sma$group2, "ۦaj", Within_name, "O", 
                            mix_B1_sma$group1, "C")
    mix_sim_B1a_sm1 = paste0(mix_sim_B1a_sm, collapse = "" )
    mix_sim_B1a_re1 = paste0("BonferroniƫվܡG", mix_sim_B1a_sm1)
  } 
  if(nrow(mix_B1_lara) != 0 & nrow(mix_B1_sma) != 0) {
    mix_sim_B1a_la = paste0(Within_name, "O", mix_B1_lara$group1, "ۦaj", Within_name, "O", mix_B1_lara$group2, "C")
    mix_sim_B1a_lB1 = paste0(mix_sim_B1a_la, collapse = "" )
    mix_sim_B1a_sm = paste0(Within_name, "O", mix_B1_sma$group2, "ۦaj", Within_name, "O", 
                            mix_B1_sma$group1, "C")
    mix_sim_B1a_sm1 = paste0(mix_sim_B1a_sm, collapse = "" )
    mix_sim_B1a_re1 = paste0("BonferroniƫվܡG", mix_sim_B1a_lB1, mix_sim_B1a_sm1)
  }
 }
 }
  mix_sim_B1a_re2 = paste0(mix_sim_B1_re, mix_sim_B1a_re1)
}
mixB1a = t(c(1:length(levels(dat_m1$Within))))
mixB1B1 = to("miB", length(levels(dat_m1$Within)))
colnames(mixB1a) = mixB1B1
mix_sim_B1_out_re = apply(mixB1a, 2, mix_simple_B1_re)
mix_sim_B1_out_re1 = paste0(mix_sim_B1_out_re, collapse = "")
mix_sim_B1_out_re1
#######################################################################################
#DnĪGƫ
kk = matrix("", nrow = 3, ncol = 1)
colnames(kk) = c("ƫ")
post_mix_main_A1_leven = leveneTest(scores ~ Between, data = dat_m1)
post_mix_main_A1 = aov(scores ~ Between, data = dat_m1)
if(mix_ano_tab$p[1] > 0.05) {
     po_main_A1_out = c("")
   } 
if(mix_ano_tab$p[1] <= 0.05 ){
   if(length(levels(dat_m1$Between)) == 2) {
     mix_main_A1_msd = group_by(dat_m1, Between) %>%
       summarise(
         mean = round(mean(scores, na.rm = TRUE), 3),
         sd = round(sd(scores, na.rm = TRUE), 3), .groups = 'drop'
       )
      
   if (mix_main_A1_msd$mean[1] - mix_main_A1_msd$mean[2] > 0) {
        po_main_A1_out = paste0(Between_subjects_var, "O", mix_main_A1_msd$Between[1], 
                                "b", Within_name, "ۦaj", 
                                Between_subjects_var, "O", mix_main_A1_msd$Between[2], "C")
        kk[1,1] = paste0(mix_main_A1_msd$Between[1], " > ", mix_main_A1_msd$Between[2])
      }
    if (mix_main_A1_msd$mean[1] - mix_main_A1_msd$mean[2] < 0) {
        po_main_A1_out = paste0(Between_subjects_var, "O", mix_main_A1_msd$Between[2], 
                                "b", Within_name, "ۦaj",  
                                Between_subjects_var, "O", mix_main_A1_msd$Between[1], "C")
        kk[1,1] = paste0(mix_main_A1_msd$Between[2], " > ", mix_main_A1_msd$Between[1])
    }
 }
 if(length(levels(dat_m1$Between)) >= 3) {
  if(post_mix_main_A1_leven$`Pr(>F)`[1] > 0.05) {
    ano_main_A1_post = DescTools::PostHocTest(post_mix_main_A1, method = c("scheffe"))
    sch_Be   = data.frame(ano_main_A1_post$Between)
    sch_Be$names  =  rownames(sch_Be)
    names_1 = reshape2::colsplit(sch_Be$names,"-", names = c("group1","group2"))
    sch_A = cbind(sch_Be, names_1)
    po_Be_la  = sch_A %>% filter(sch_A$pval <= 0.05 & sch_A$diff > 0)
    po_Be_lar = paste0(po_Be_large$group1, " > ", po_Be_large$group2, collapse = "F")
    po_Be_sm  = sch_A %>% filter(sch_A$pval <= 0.05 & sch_A$diff < 0)
    po_Be_smr = paste0(po_Be_small$group2, " > ", po_Be_small$group1, collapse = "F")
    
    if(nrow(po_Be_la) == 0 & nrow(po_Be_sm) == 0) {
      po_main_A1_out = paste0("gScheffeƫA̵MSէOۮtC")
      kk[1,1] = c("gScheffeƫASէOۮt")
    }
    if(nrow(po_Be_la) != 0 & nrow(po_Be_sm) == 0) {
      mix_Be_out = paste0(Between_subjects_var, "էO", po_Be_la$group1, "b", Within_name, "ۦajէO", 
                     po_Be_la$group2, collapse = "F")
      po_main_A1_out = paste0("gScheffeƫA", mix_Be_out, "C")
      kk[1,1] = po_Be_lar
    }
    if(nrow(po_Be_la) == 0 & nrow(po_Be_sm) != 0) {
      mix_Be_out1 = paste0(Between_subjects_var, "էO", po_Be_sm$group2, "b", Within_name, "ۦajէO", 
                          po_Be_sm$group1, collapse = "F")
      po_main_A1_out = paste0("gScheffeƫA", mix_Be_out1, "C")
      kk[1,1] = po_Be_smr
    }
    if(nrow(po_Be_la) != 0 & nrow(po_Be_sm) != 0) {
      mix_Be_out2 = paste0(Between_subjects_var, "էO", po_Be_la$group1, "b", Within_name, "ۦajէO", 
                          po_Be_la$group2, collapse = "F")
      mix_Be_out3 = paste0(Between_subjects_var, "էO", po_Be_sm$group2, "b", Within_name, "ۦajէO", 
                          po_Be_sm$group1, collapse = "F")
      po_main_A1_out = paste0("gScheffeƫA", mix_Be_out2, mix_Be_out3, "C")
      kk[1,1] = paste0(po_Be_lar, po_Be_smr)
    }
    
    } else {
      gh_Be  = dat_m1 %>% games_howell_test(scores ~ Between)
      gh_post = c("gGames-HowellƫA")
      po_Be_la   = gh_Be %>% filter(gh_Be$p.adj <= 0.05 & gh_Be$estimate > 0)
      po_Be_lar  = paste0("O", po_Be_la$group1, "b", Within_name,  "ۦaj", 
                          "O", po_Be_la$group2, collapse = "F")
      po_Be_sm   = gh_Be %>% filter(gh_Be$p.adj <= 0.05 & gh_Be$estimate < 0)
      po_Be_smr  = paste0("O", po_Be_sm$group2, "b", Within_name, "ۦaj", 
                          "O", po_Be_sm$group1, collapse = "F")
      la = paste0(po_Be_la$group1, " > ", po_Be_la$group2, collapse = "F")
      sm = paste0(po_Be_sm$group2, " > ", po_Be_sm$group1, collapse = "F")
      if(nrow(po_Be_la) == 0 & nrow(po_Be_sm) == 0) {
        po_main_A1_out = paste0("gGames-HowellƫA̵MSէOۮtC")
        kk[1,1] = c("")
      }
      if(nrow(po_Be_la) != 0 & nrow(po_Be_sm) == 0) {
        po_main_A1_out = paste0(gh_post, po_Be_lar, "C")
        kk[1,1] = paste0(gh_post, la)
      }
      if(nrow(po_Be_la) == 0 & nrow(po_Be_sm) != 0) {
        po_main_A1_out = paste0(gh_post, po_Be_smr, "C")
        kk[1,1] =  paste0(gh_post, sm)
      }
      if(nrow(po_Be_la) != 0 & nrow(po_Be_sm) != 0) {
        po_main_A1_out = paste0(gh_post, po_Be_lar, po_Be_smr, "C")
        kk[1,1] = paste0(gh_post, la, "F", sm)
      } 
    }
  }
}

#WithinDnĪGƫ˩w
if(mix_ano_tab$p[2] > 0.05) {
  po_main_B1_out = c("")
} 
if(mix_ano_tab$p[2] <= 0.05) {
  if(length(levels(dat_m1$Within)) == 2) {
     mix_main_B1_msd = group_by(dat_m1, Within) %>%
     summarise(
      mean = round(mean(scores, na.rm = TRUE), 3),
      sd = round(sd(scores, na.rm = TRUE), 3), .groups = 'drop'
    )
  
     
  if (mix_main_B1_msd$mean[1] - mix_main_B1_msd$mean[2] > 0) {
      po_main_B1_out = paste0(Within_name, "O", mix_main_B1_msd$Within[1], 
                              "b", Within_name, "ۦaj", 
                              Within_name, "O", mix_main_B1_msd$Within[2], "C")
      kk[2,1] = paste0(mix_main_B1_msd$Within[1], " > ", mix_main_B1_msd$Within[2])
  }
  if (mix_main_B1_msd$mean[1] - mix_main_B1_msd$mean[2] < 0) {
      po_main_B1_out = paste0(Within_name, "O", mix_main_B1_msd$Within[2], 
                              "b", Within_name, "ۦaj", 
                              Within_name, "O", mix_main_B1_msd$Within[1], "C")
      kk[2,1] = paste0(mix_main_B1_msd$Within[2], " > ", mix_main_B1_msd$Within[1])
    }
  }
mix_main_B1_post = dat_m1 %>%
  pairwise_t_test(
    scores ~ Within, paired = TRUE, 
    p.adjust.method = "bonferroni"
  )
if(length(levels(dat_m1$Within)) >= 3) {
  mix_main_B1_la   = mix_main_B1_post %>% filter(p.adj <= 0.05 & statistic > 0)
  mix_main_B1_sm   = mix_main_B1_post %>% filter(p.adj <= 0.05 & statistic < 0)
  bo = c("BonferroniƫվG")
  if(nrow(mix_main_B1_la) == 0 & nrow(mix_main_B1_sm) == 0) {
    po_main_B1_out = paste0("BonferroniƫվA̵MSէOۮtC")
    kk[2,1] = c("")
  }
  if(nrow(mix_main_B1_la) != 0 & nrow(mix_main_B1_sm) == 0) {
    mix_main_B1_la1 = paste0("O", mix_main_B1_la$group1, "b", Within_name, 
                          "ۦaj", "O", 
                          mix_main_B1_la$group2, collapse = "F")
    po_main_B1_out = paste0(mix_main_B1_la1, "C")
    lass = paste0(mix_main_B1_la$group1, " > ", mix_main_B1_la$group2, collapse = "F")
    kk[2,1] = paste0(bo, lass)
  }  
  if(nrow(mix_main_B1_la) == 0 & nrow(mix_main_B1_sm) != 0) {
    mix_main_B1_sm1 = paste0("O", mix_main_B1_sm$group2, "b", Within_name, 
                          "ۦaj", "O", 
                          mix_main_B1_sm$group1, collapse = "F")
    po_main_B1_out = paste0(mix_main_B1_sm1, "C")
    smss = paste0(mix_main_B1_sm$group2, " > ", mix_main_B1_sm$group1, collapse = "F")
    kk[2,1] = paste0(bo, smss)
  } 
  if(nrow(mix_main_B1_la) != 0 & nrow(mix_main_B1_sm) != 0) {
    mix_main_B1_la1 = paste0("O", mix_main_B1_la$group1, "b", Within_name, 
                          "ۦaj", "O", 
                          mix_main_B1_la$group2, collapse = "F")
    mix_main_B1_sm1 = paste0("O", mix_main_B1_sm$group2, "b", Within_name, 
                          "ۦaj", "O", 
                          mix_main_B1_sm$group1, collapse = "F")
    po_main_B1_out = paste0(mix_main_B1_la1, "F", mix_main_B1_sm1, "C")
    kk1 = paste0(mix_main_B1_la$group1, " > ", mix_main_B1_la$group2, collapse = "F")
    kk2 = paste0(mix_main_B1_sm$group2, " > ", mix_main_B1_sm$group1, collapse = "F")
    kk[2,1] = paste0(bo, kk1, "F", kk2)
  } 
 } 
}
###########################################################################################
##GX
mix_A1_a = matrix("", nrow = 1, ncol = 9)
mix_A1_a[1,1] = c(paste0(Within_name, "b", Between_subjects_var))
colnames(mix_A1_a) = c("ܲӷ", "SS", "~tSS", "df", "~tdf",  "F", "p.adj", 
                       "b2", "Bonferroniվƫ")
mix_B1_a = matrix("", nrow = 1, ncol = 9)
mix_B1_a[1,1] = c(paste0(Between_subjects_var, "b", Within_name))
colnames(mix_B1_a) = c("ܲӷ", "SS", "~tSS", "df", "~tdf",  "F", "p.adj", 
                       "b2", "Bonferroniվƫ")
mix_sim_AB_tab = rbind(mix_A1_a, mix_sim_A1_out1, mix_B1_a, mix_sim_B1_out1)
mix_norm_re2 = paste0("ѪBBBoA", mix_norm_re1)
mix_leven_a = paste0(mix_leven_out1, collapse = "")
mix_leven_a1 = paste0("ѪCCCoA", mix_leven_a)
mix_Box_a = paste0("ѪDDDoA", mix_box_out)
mix_inter_aa = c("ѩ椬@ήĪGFۤǡAҥHi@B˩w¥DnĪGA¥DnĪG˩wGe{GGG]result.8^AG:")
mix_inter_aa1 = paste0(mix_sim_A1_out_re, collapse = "")
mix_inter_bb1 = paste0(mix_sim_B1_out_re, collapse = "")
mix_inter_out = paste0(mix_inter_aa, mix_inter_aa1, mix_inter_bb1)
mix_main_aa  = c("ѩ椬@ήĪGFۤǡAҥH靈۪DnĪGƫRAG:")
mix_ano_tab1 = cbind(mix_ano_tab, kk)
if(length(unique(dat_m1$Within)) == 2){
  mix_out_1 = paste0("HG]lVX]pANOVAR", Between_subjects_var, "P", Within_name,
                     "Oܶܶ", Within_name, "ƤĪGAUӮyzέppAAA]result.1^A",
                     "Shapiro-Wilk`A˩wpBBB]result.2^A",
                     "LevenܲƦP˩wpCCC]result.3^ABox's Mܲ-@ܼƯx}P˩wpDDD]result.4^A",
                     Between_subjects_var, "P", Within_name,
                     "Oܶܶ", Within_name, "ƤANOVAKnpEEE]result.5^C")
  mix_out_re_a = paste0("ѪEEEANOVAKnoG", mix_out_re)
  mix_out_re_a1 = paste0(mix_out_1, mix_norm_re2, mix_leven_a1, mix_Box_a, mix_out_re_a)
  
if(mix_ano_tab$p[1] > 0.05 & mix_ano_tab$p[2] > 0.05 & mix_ano_tab$p[3] > 0.05) {
   mix_ano_result = list(nmixr_out1, aa4, mix_le, mix_box, mix_ano_tab, mix_out_1, 
                         mix_norm_re2, mix_leven_a1, mix_Box_a, mix_out_re_a)
} 
if(mix_ano_tab$p[3] <= 0.05){
  mix_ano_result = list(nmixr_out1, aa4, mix_le, mix_box, mix_ano_tab, mix_out_1, 
                        mix_norm_re2, mix_leven_a1, mix_Box_a, mix_out_re_a,
                        mix_sim_AB_tab, mix_inter_out)
} else {
  if(mix_ano_tab$p[1] <= 0.05 & mix_ano_tab$p[2] > 0.05) {
    mix_AAA = paste0(mix_out_re_a1, mix_main_aa, po_main_A1_out)
    mix_ano_result = list(nmixr_out1, aa4, mix_le, mix_box, mix_ano_tab1, mix_AAA)
  }
  if(mix_ano_tab$p[1] > 0.05 & mix_ano_tab$p[2] <= 0.05) {
    mix_BBB = paste0(mix_out_re_a1, mix_main_aa, po_main_B1_out)
    mix_ano_result = list(nmixr_out1, aa4, mix_le, mix_box, mix_ano_tab1, mix_BBB)
  }
  if(mix_ano_tab$p[1] <= 0.05 & mix_ano_tab$p[2] <= 0.05) {
    mix_ABAB = paste0(mix_out_re_a1, mix_main_aa, po_main_A1_out, po_main_B1_out)
    mix_ano_result = list(nmixr_out1, aa4, mix_le, mix_box, mix_ano_tab1, mix_ABAB)
  }
} 
} else {
  mix_out_1 = paste0("HG]lVX]pANOVAR", Between_subjects_var, "P", Within_name,
                     "Oܶܶ", Within_name, "ƤĪGAUӮyzέppAAA]result.1^A",
                     "Shapiro-Wilk`A˩wpBBB]result.2^ALevenܲƦP˩wpCCC]result.3^A",
                     "Box's Mܲ-@ܼƯx}P˩wpDDD]result.4^A",
                     "Mauchlyy˩wpEEE]result.5^A", Between_subjects_var, "P", Within_name,
                     "Oܶܶ", Within_name, "ƤANOVAKnpFFF]result.6^C")
  mix_Mauch_a = paste0("ѪEEEoA", mix_Mau_out1)
  mix_out_re_a = paste0("ѪFFFANOVAKnoG", mix_out_re)
  mix_out_re_a1 = paste0(mix_out_1, mix_norm_re2, mix_leven_a1, mix_Box_a, mix_Mauch_a, mix_out_re_a)
  mix_out_1a = list(nmixr_out1, aa4, mix_le, mix_box, mix_ano_tab, mix_out_re_a1)
  
  if(mix_ano_tab$p[1] > 0.05 & mix_ano_tab$p[2] > 0.05 & mix_ano_tab$p[3] > 0.05) {
    mix_ano_result = mix_out_1a
  } 
  if(mix_ano_tab$p[3] <= 0.05){
    mix_ano_result = list(nmixr_out1, aa4, mix_le, mix_box, mix_Mauch, mix_ano_tab, mix_out_1, 
                          mix_norm_re2, mix_leven_a1, mix_Box_a, mix_Mauch_a, mix_out_re_a,
                          mix_sim_AB_tab, mix_inter_out)
  } else {
    if(mix_ano_tab$p[1] <= 0.05 & mix_ano_tab$p[2] > 0.05) {
      mix_AAA = paste0(mix_out_re_a1, mix_main_aa, po_main_A1_out)
      mix_ano_result = list(nmixr_out1, aa4, mix_le, mix_box, mix_Mauch, mix_ano_tab1, mix_AAA)
    }
    if(mix_ano_tab$p[1] > 0.05 & mix_ano_tab$p[2] <= 0.05) {
      mix_BBB = paste0(mix_out_re_a1, mix_main_aa, po_main_B1_out)
      mix_ano_result = list(nmixr_out1, aa4, mix_le, mix_box, mix_Mauch, mix_ano_tab1, mix_BBB)
    }
    if(mix_ano_tab$p[1] <= 0.05 & mix_ano_tab$p[2] <= 0.05) {
      mix_ABAB = paste0(mix_out_re_a1, mix_main_aa, po_main_A1_out, po_main_B1_out)
      mix_ano_result = list(nmixr_out1, aa4, mix_le, mix_box, mix_Mauch, mix_ano_tab1, mix_ABAB)
    }
  }  
}

mix_AOV.savecsv = paste0(save_file, ".csv")
write.list(z = mix_ano_result, file = mix_AOV.savecsv, row.names = F)
##e椬@ι
mix_inter_plot <- 
  dat_m1 %>% 
  group_by(Between, Within) %>% 
  summarise( = mean(scores, na.rm = T), .groups = 'drop')
  mix_plot_A = ggplot(mix_inter_plot, 
                      aes(x = Between, y = , 
                          group = Within)) +
    geom_point(aes(shape = Within), size = 4) +
    scale_shape(name = Within_name) +
    geom_line(size = 1) +
    xlab(Between_subjects_var) 
  mix_plot_B = ggplot(mix_inter_plot, 
                      aes(x = Within, y = , 
                          group = Between)) +
    geom_point(aes(shape = Between), size = 4) +
    scale_shape(name = Between_subjects_var) +
    geom_line(size = 1) +
    xlab(Within_name) 
##s
png("mix_plot_A.png")
print(mix_plot_A)
dev.off()

png("mix_plot_B.png")
print(mix_plot_B)
dev.off()
while (!is.null(dev.list()))  dev.off()
   }
  } 
 }
} #############  {    ############################

