##################   ̼ۨ˥t˩w   ##################
#пJƪW
data = burnout_1
# пJܶW(ܶW١AṲ̄@wnݳ椸2.7Ʈس)
dependent_var = c("PƤ", "ժ")
#пJXGW
save_file = c("pair_out")
###############################################################################
library(tidyverse)
library(effsize)
library(psych)
###############################################################################
pair_da =  select(data, all_of(dependent_var))
colnames(pair_da) = c("p1", "p2")
if(!is.numeric(pair_da$p1) | !is.numeric(pair_da$p2)){
  AB_output = c("GܶܶOƭܶALk̼ۨ˥t˩wC")
  AB_output = data.frame(AB_output)
  colnames(AB_output) = c("ĵi")
  cat("ĵiGGܶܶOƭܶALk̼ۨ˥t˩wC")
  AB_outcsv = paste0(save_file, ".xlsx")
  write_xlsx(AB_output, AB_outcsv)
} else {
  if(length(unique(pair_da$p1)) == 1 | length(unique(pair_da$p2)) == 1){
    AB1_output = c("Gܶܶu@ӭȡALk̼ۨ˥t˩wC")
    AB1_output = data.frame(AB1_output)
    colnames(AB1_output) = c("ĵi")
    cat("ĵiGGܶܶu@ӭȡALk̼ۨ˥t˩wC")
    AB1_outcsv = paste0(save_file, ".xlsx")
    write_xlsx(AB1_output, AB1_outcsv)  
  } else {
pair_da1 =  select(data, all_of(dependent_var))
pair_var = colnames(pair_da1)
pair_t = t.test(pair_da$p1, pair_da$p2, paired = TRUE, 
                alternative = "two.sided")
d = pair_da$p1 - pair_da$p2
sh_out    = shapiro.test(d)
skew_kur  = describe(d)
if (sh_out$p.value > 0.05) {
  norm_out = paste0("AAA(result.1)ShapiroVWilk`A˩wܡAShapiroVWilkέpq = ", round(sh_out$statistic, 3), 
                    "Ap = ", round(sh_out$p.value, 3), " > 0.05Aܱ`AʰwߡC")
} else {
  norm_1 = paste0("AAA(result.1)ShapiroVWilk`A˩wܡAShapiroVWilkέpq = ", round(sh_out$statistic, 3), 
                  "Ap = ", round(sh_out$p.value, 3), " < 0.05 Ai@B˩wAȻPp׭ȡC")
  if(abs(round(skew_kur$skew, 3)) >= 3) { 
    norm_ske = paste0("A = ", round(skew_kur$skew, 3), "AȤj3AܦYA{HC")
  } else {
    norm_ske = paste0("A = ", round(skew_kur$skew, 3), "AȤp3AܨSYA{HC")  
  }
  
  if(abs(round(skew_kur$kurtosis, 3)) >= 10) { 
    norm_kur = paste0("p׭ = ", round(skew_kur$kurtosis, 3), "A>10AܦYL󥭩Zΰ~k{HC")
  } else {
    norm_kur = paste0("p׭ = ", round(skew_kur$kurtosis, 3), "Aȡ10AܨSYL󥭩Zΰ~k{HC")  
  }
  if(abs(round(skew_kur$skew, 3)) >= 3 & abs(round(skew_kur$kurtosis, 3)) >= 10) {
    norm_out = paste0(norm_1, norm_ske, norm_kur, "ѩShapiroVWilk`A˩wܫD`AA",
                      "BAܦYA{HAp׭ܦYL󥭩Zΰ~k{HA",
                      "]iHPwYHϱ`AʡC",
                      "(Ū̥iѦҡu`AwߪBz覡v@p`AMDѨM覡C)")
  }
  if(abs(round(skew_kur$skew, 3)) >= 3) {
    norm_out = paste0(norm_1, norm_ske, norm_kur, "ѩShapiroVWilk`A˩wܫD`AA",
                      "BAܦYA{HA]iHPwHϱ`AʡC", 
                      "(Ū̥iѦҡu7.2.2̼ۨ˥t˩wwv@p`AMDѨM覡C)")
  }
  
  if(abs(round(skew_kur$kurtosis, 3)) >= 10) {
    norm_out = paste0(norm_1, norm_ske, norm_kur, "ѩShapiroVWilk`A˩wܫD`AA",
                      "Bp׭ܦYL󥭩Zΰ~k{HA]iHPwHϱ`AʡC", 
                      "(Ū̥iѦҡu7.2.2̼ۨ˥t˩wwv@p`AMDѨM覡C)")
  }
  
  if(abs(round(skew_kur$skew, 3)) < 3 & abs(round(skew_kur$kurtosis, 3)) < 10) {
    norm_out = paste0(norm_1, norm_ske, norm_kur, "MShapiroVWilk`A˩wܫD`A", 
                      "AMӰAܨSYA{HAp׭ܨSYL󥭩Zΰ~k{HA",
                      "]̵MiHϥά̼ۨ˥t˩wC" )
  }
}

t_tab =  matrix("", nrow = 3, ncol = 3)
t_tab[1,1] = c("ShapiroVWilk˩w")
t_tab[1,2] = round(sh_out$statistic, 3)
t_tab[1,3] = round(sh_out$p.value, 3)
t_tab[2,1] = c("A(Skewness)")
t_tab[2,2] = round(skew_kur$skew, 3)
t_tab[3,1] = c("p(Kurtosis)")
t_tab[3,2] = round(skew_kur$kurtosis, 3)
colnames(t_tab) = c("˩w", "έpq", "p")

pair_msd = psych::describe(pair_da1) %>% select(c(2, 3, 4)) %>% 
           mutate_if(is.numeric, round, 3)
pair_value = c(round(pair_t$statistic, 3), NA)
pair_df = c(pair_t$parameter, NA)
pair_p = c(round(pair_t$p.value, 4), NA)


id <- rownames(pair_da)
pair_da2 <- cbind(id = id, pair_da)
pair_long <- pair_da2 %>% gather(group, score, p1:p2, factor_key=TRUE)
pair_cohen = effsize::cohen.d(score ~ group | Subject(id), data = pair_long, paired = T)
cohen_d = round(pair_cohen$estimate, 3)

if(abs(cohen_d) < 0.2) {
  eff_1 = c("LzĪG")
}
if(abs(cohen_d) >= 0.2 && abs(cohen_d) < 0.5) {
  eff_1 = c("pĪG")
}
if(abs(cohen_d) >= 0.5 && abs(cohen_d) < 0.8) {
  eff_1 = c("ĪG")
}
if(abs(cohen_d) >= 0.8) {
  eff_1 = c("jĪG")
}
effec = c(cohen_d, eff_1)
pair_tab = cbind(pair_var, pair_msd, pair_value, pair_df, pair_p, effec)
colnames(pair_tab) = c("էO", "N", "", "зǮt", "t", "ۥѫ", "p", "ĪGq(d)")
pair_tab[is.na(pair_tab)] <- " "

if (pair_t$p.value > 0.05) {
    pair_res = paste0(pair_tab$էO[1], "P", pair_tab$էO[2],"̼ۨ˥t˩wGpBBB(result.3)AGtȬ", 
                      pair_value[1], "Adf", pair_df[1], "Ap > 0.05A", "d = ", cohen_d, 
                      "AFۤǡA", pair_tab$էO[1], "(", "M = ", 
                      pair_tab$[1], ", sd = ", pair_tab$зǮt[1], ")", "P", 
                      pair_tab$էO[2], "(", "M = ", 
                      pair_tab$[2], ", sd = ", pair_tab$зǮt[2], ")",
                      "S۪tC")
}

if(pair_t$p.value <= 0.05 & pair_t$p.value > 0.01) {
  if(pair_tab$[1] > pair_tab$[2]) {
    pair_res = paste0(pair_tab$էO[1], "P", pair_tab$էO[2],"̼ۨ˥t˩wGpBBB(result.3)AGtȬ", 
                      pair_value[1], "Adf", pair_df[1], "Ap < 0.05A", "d = ", cohen_d, 
                      "AFۤǡA", pair_tab$էO[1], "(", "M = ", 
                      pair_tab$[1], ", sd = ", pair_tab$зǮt[1], ")", "P", 
                      pair_tab$էO[2], "(", "M = ", pair_tab$[2], ", sd = ", 
                      pair_tab$зǮt[2], ")", " ۪tCqo", 
                      pair_tab$էO[1], "ۦaj", pair_tab$էO[2], "ơC")
    
      } else {
        pair_res = paste0(pair_tab$էO[1], "P", pair_tab$էO[2],"̼ۨ˥t˩wGpBBB(result.3)AGtȬ",
                          pair_value[1], "Adf", pair_df[1], "Ap < 0.05A", "d = ", cohen_d, 
                          "AFۤǡA", pair_tab$էO[1], "(", "M = ", 
                          pair_tab$[1], ", sd = ", pair_tab$зǮt[1], ")", "P", 
                          pair_tab$էO[2], "(", "M = ", pair_tab$[2], ", sd = ", 
                          pair_tab$зǮt[2], ")", " ۪tCqo", 
                          pair_tab$էO[2], "ۦaj", pair_tab$էO[1], "ơC") 
    
  }
}

if(pair_t$p.value <= 0.01 & pair_t$p.value > 0.001) {
  if(pair_tab$[1] > pair_tab$[2]) {
    pair_res = paste0(pair_tab$էO[1], "P", pair_tab$էO[2],"̼ۨ˥t˩wGpBBB(result.3)AGtȬ",
                      pair_value[1], "Adf", pair_df[1], "Ap < 0.01A", "d = ", cohen_d, 
                      "AFۤǡA", pair_tab$էO[1], "(", "M = ", 
                      pair_tab$[1], ", sd = ", pair_tab$зǮt[1], ")", "P", 
                      pair_tab$էO[2], "(", "M = ", pair_tab$[2], ", sd = ", 
                      pair_tab$зǮt[2], ")", " ۪tCqo", 
                      pair_tab$էO[1], "ۦaj", pair_tab$էO[2], "ơC")
    
  } else {
    pair_res = paste0(pair_tab$էO[1], "P", pair_tab$էO[2],"̼ۨ˥t˩wGpBBB(result.3)AGtȬ",
                      pair_value[1], "Adf", pair_df[1], "Ap < 0.01A", "d = ", cohen_d, 
                      "AFۤǡA", pair_tab$էO[1], "(", "M = ", 
                      pair_tab$[1], ", sd = ", pair_tab$зǮt[1], ")", "P", 
                      pair_tab$էO[2], "(", "M = ", pair_tab$[2], ", sd = ", 
                      pair_tab$зǮt[2], ")", " ۪tCqo", 
                      pair_tab$էO[2], "ۦaj", pair_tab$էO[1], "ơC") 
    
  }
}

if(pair_t$p.value <= 0.001) {
  if(pair_tab$[1] > pair_tab$[2]) {
    pair_res = paste0(pair_tab$էO[1], "P", pair_tab$էO[2],"̼ۨ˥t˩wGpBBB(result.3)AGtȬ",
                      pair_value[1], "Adf", pair_df[1], "Ap < 0.001A", "d = ", cohen_d, 
                      "AFۤǡA", pair_tab$էO[1], "(", "M = ", 
                      pair_tab$[1], ", sd = ", pair_tab$зǮt[1], ")", "P", 
                      pair_tab$էO[2], "(", "M = ", pair_tab$[2], ", sd = ", 
                      pair_tab$зǮt[2], ")", " ۪tCqo", 
                      pair_tab$էO[1], "ۦaj", pair_tab$էO[2], "ơC")
    
  } else {
    pair_res = paste0(pair_tab$էO[1], "P", pair_tab$էO[2],"̼ۨ˥t˩wGpBBB(result.3)AGtȬ",
                      pair_value[1], "Adf", pair_df[1], "Ap < 0.001A", "d = ", cohen_d, 
                      "AFۤǡA", pair_tab$էO[1], "(", "M = ", 
                      pair_tab$[1], ", sd = ", pair_tab$зǮt[1], ")", "P", 
                      pair_tab$էO[2], "(", "M = ", pair_tab$[2], ", sd = ", 
                      pair_tab$зǮt[2], ")", " ۪tCqo", 
                      pair_tab$էO[2], "ۦaj", pair_tab$էO[1], "ơC") 
    
  }
}

pair_f = list(t_tab, norm_out, pair_tab, pair_res)
paircsv = paste0(save_file, ".csv")
write.list(z = pair_f, file = paircsv, row.names = F)
  }
}###  { ###############################################
