########## 8.1 ]lW߼˥ܲƤR ##########
###### 8.1.8 ˬd]lW߼˥ ANOVA w ######

ANO_model = aov(u@t ~ factor(¾), data = burnout_1)
shapiro_test(ANO_model$residuals)

library(psych)
skew(ANO_model$residuals)
kurtosi(ANO_model$residuals)

library(rstatix)
burnout_1 %>% levene_test(u@t ~ factor(¾))

###### 8.1.9 R ]lW߼˥ ANOVA R ######

ANO_model = aov(u@t ~ factor(¾), data = burnout_1)
summary(ANO_model)

library(DescTools)
PostHocTest(ANO_model, method = c("scheffe"))

library(sjstats)
anova_sta = anova_stats(ANO_model) anova_sta$partial.etasq[1]

group_by(burnout_1, ¾) %>%
  summarise(count = n(), mean = round(mean(u@t, na.rm = TRUE), 3),
            sd = round(sd(u@t , na.rm = TRUE), 3), .groups = "drop")

########## 8.2 ]l̼ۨ˥ܲƤR ##########
###### 8.2.7 ]l̼ۨ˥ ANOVA dһP ######

library(tidyverse)
da_repeat = burnout_1 %>% select(c(" u@t ", " ǥͰD ", " aO "))
id = rownames(da_repeat)
da_repeat1 = cbind(id = id, da_repeat)
da_repeat_long = da_repeat1 %>% gather(group, score, u@t:aO, factor_key=TRUE)

library(rstatix)
da_repeat_long %>%
  group_by(group) %>% 
  shapiro_test(score)

library(psych)
da_repeat_long %>%
  group_by(group) %>% 
  summarize(skew(score), kurtosi(score))

library(rstatix)
rep_tab = anova_test(data = da_repeat_long, dv = score, wid = id, within = group)
rep_tab

get_anova_table(rep_tab)

pairwise.t.test(da_repeat_long$score, da_repeat_long$group, p.adj = "bonferroni", paired = TRUE)

da_repeat_long %>% group_by(group) %>%
  summarise(count = n(), mean = round(mean(score, na.rm = TRUE), 3),
            sd = round(sd(score, na.rm = TRUE), 3), .groups = "drop" )




